/***************************************************************************
                            kde_DCOPObjectProxy.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_DCOPOBJECTPROXY
#define KDE_DCOPOBJECTPROXY

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 You must use a proxy if you want to dispatch method calls for
 object IDs which dont have (yet) a corresponding @ref DCOPObject.
 This is somewhat like virtual object references in CORBA.

 @author Matthias Ettrich <ettrich@kde.org>
 
 @short *
 You must use a proxy if you want to dispatch method calls for
 object IDs which dont have (yet) a corresponding @ref DCOPObject.
*/

/** *
 Creates a new proxy.
     
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_DCOPObjectProxy * kde_new_DCOPObjectProxy();

/** *
 Obsolete, do not use. DCOP clients know about object proxies
 automatically.

     
*/
kde_DCOPObjectProxy * kde_new_DCOPObjectProxy1(kde_DCOPClient* arg1);

/** *
 Destroy the proxy.
     
*/
void kde_del_DCOPObjectProxy( kde_DCOPObjectProxy* p );

/** *
 Reimplement this method to dispatch method calls.

 This method is called of all proxies if the @ref DCOPClient
 knows no object with the id @p obj. If the first proxy returns
 @p true, the @ref DCOPClient will no longer call other proxies.

 The object id @p obj may be empty for app-wide function calls no
 associated with any object.

*/
int kde_DCOPObjectProxy_process(kde_DCOPObjectProxy* instPointer,qt_QCString* obj, qt_QCString* fun, qt_QByteArray* data, qt_QCString* replyType, qt_QByteArray* replyData);
void kde_DCOPObjectProxy_virtual_hook(kde_DCOPObjectProxy* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
