/***************************************************************************
                            kde_DOMNodeList.h -  description
                             -------------------
    begin                : Sun Oct 21 19:45:22 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Oct 21 19:45:22 2001, using kdoc $.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_NODELIST
#define KDE_NODELIST

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**

 The <code> NodeList </code> interface provides the abstraction of
 an ordered collection of nodes, without defining or constraining
 how this collection is implemented.

  The items in the <code> NodeList </code> are accessible via an
 integral index, starting from 0.


 @short
 The <code> NodeList </code> interface provides the abstraction of
 an ordered collection of nodes, without defining or constraining
 how this collection is implemented.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_DOMNodeList * kde_new_DOMNodeList();
kde_DOMNodeList * kde_new_DOMNodeList1(kde_DOMNodeList* other);
void kde_del_DOMNodeList( kde_DOMNodeList* p );

/**
 The number of nodes in the list. The range of valid child node
 indices is 0 to <code> length-1 </code> inclusive.


*/
unsigned long kde_DOMNodeList_length(kde_DOMNodeList* instPointer);

/**
 Returns the <code> index </code> th item in the collection. If
 <code> index </code> is greater than or equal to the number of
 nodes in the list, this returns <code> null </code> .


*/
kde_DOMNode* kde_DOMNodeList_item(kde_DOMNodeList* instPointer,unsigned long index);

/**

 not part of the DOM

*/
int kde_DOMNodeList_isNull(kde_DOMNodeList* instPointer);

#ifdef __cplusplus
}
#endif
#endif
