/***************************************************************************
                            kde_HTMLAnchorElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLANCHORELEMENT
#define KDE_HTMLANCHORELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 The anchor element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#edef-A"> A
 element definition </a> in HTML 4.0.

 
 @short *
 The anchor element.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLAnchorElement * kde_new_HTMLAnchorElement();
kde_HTMLAnchorElement * kde_new_HTMLAnchorElement1(kde_HTMLAnchorElement* other);
kde_HTMLAnchorElement * kde_new_HTMLAnchorElement2(kde_DOMNode* other);
void kde_del_HTMLAnchorElement( kde_HTMLAnchorElement* p );

/** *
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_accessKey(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref accessKey
     
*/
void kde_HTMLAnchorElement_setAccessKey(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 The character encoding of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-charset">
 charset attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_charset(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref charset
     
*/
void kde_HTMLAnchorElement_setCharset(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Comma-separated list of lengths, defining an active region
 geometry. See also <code> shape </code> for the shape of the
 region. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-coords">
 coords attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_coords(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref coords
     
*/
void kde_HTMLAnchorElement_setCoords(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 The URI of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-href">
 href attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_href(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref href
     
*/
void kde_HTMLAnchorElement_setHref(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Language code of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-hreflang">
 hreflang attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_hreflang(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref hreflang
     
*/
void kde_HTMLAnchorElement_setHreflang(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Anchor name. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-name-A">
 name attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_name(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref name
     
*/
void kde_HTMLAnchorElement_setName(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Forward link type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-rel">
 rel attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_rel(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref rel
     
*/
void kde_HTMLAnchorElement_setRel(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Reverse link type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-rev">
 rev attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_rev(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref rev
     
*/
void kde_HTMLAnchorElement_setRev(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 The shape of the active area. The coordinates are given by
 <code> coords </code> . See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-shape">
 shape attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_shape(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref shape
     
*/
void kde_HTMLAnchorElement_setShape(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLAnchorElement_tabIndex(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref tabIndex
     
*/
void kde_HTMLAnchorElement_setTabIndex(kde_HTMLAnchorElement* instPointer,long arg1);

/** *
 Frame to render the resource in. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-target">
 target attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_target(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref target
     
*/
void kde_HTMLAnchorElement_setTarget(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Advisory content type. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-type-A">
 type attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAnchorElement_type(kde_HTMLAnchorElement* instPointer);

/** *
 see @ref type
     
*/
void kde_HTMLAnchorElement_setType(kde_HTMLAnchorElement* instPointer,kde_DOMString* arg1);

/** *
 Removes keyboard focus from this element.

     
*/
void kde_HTMLAnchorElement_blur(kde_HTMLAnchorElement* instPointer);

/** *
 Gives keyboard focus to this element.

     
*/
void kde_HTMLAnchorElement_focus(kde_HTMLAnchorElement* instPointer);

#ifdef __cplusplus
}
#endif
#endif
