/***************************************************************************
                            kde_HTMLAreaElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLAREAELEMENT
#define KDE_HTMLAREAELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Client-side image map area definition. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#edef-AREA">
 AREA element definition </a> in HTML 4.0.

 
 @short *
 Client-side image map area definition.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLAreaElement * kde_new_HTMLAreaElement();
kde_HTMLAreaElement * kde_new_HTMLAreaElement1(kde_HTMLAreaElement* other);
kde_HTMLAreaElement * kde_new_HTMLAreaElement2(kde_DOMNode* other);
void kde_del_HTMLAreaElement( kde_HTMLAreaElement* p );

/** *
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_accessKey(kde_HTMLAreaElement* instPointer);

/** *
 see @ref accessKey
     
*/
void kde_HTMLAreaElement_setAccessKey(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

/** *
 Alternate text for user agents not rendering the normal content
 of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-alt">
 alt attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_alt(kde_HTMLAreaElement* instPointer);

/** *
 see @ref alt
     
*/
void kde_HTMLAreaElement_setAlt(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

/** *
 Comma-separated list of lengths, defining an active region
 geometry. See also <code> shape </code> for the shape of the
 region. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-coords">
 coords attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_coords(kde_HTMLAreaElement* instPointer);

/** *
 see @ref coords
     
*/
void kde_HTMLAreaElement_setCoords(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

/** *
 The URI of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-href">
 href attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_href(kde_HTMLAreaElement* instPointer);

/** *
 see @ref href
     
*/
void kde_HTMLAreaElement_setHref(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

/** *
 Specifies that this area is inactive, i.e., has no associated
 action. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-nohref">
 nohref attribute definition </a> in HTML 4.0.

     
*/
int kde_HTMLAreaElement_noHref(kde_HTMLAreaElement* instPointer);

/** *
 see @ref noHref
     
*/
void kde_HTMLAreaElement_setNoHref(kde_HTMLAreaElement* instPointer,int arg1);

/** *
 The shape of the active area. The coordinates are given by
 <code> coords </code> . See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-shape">
 shape attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_shape(kde_HTMLAreaElement* instPointer);

/** *
 see @ref shape
     
*/
void kde_HTMLAreaElement_setShape(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

/** *
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLAreaElement_tabIndex(kde_HTMLAreaElement* instPointer);

/** *
 see @ref tabIndex
     
*/
void kde_HTMLAreaElement_setTabIndex(kde_HTMLAreaElement* instPointer,long arg1);

/** *
 Frame to render the resource in. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-target">
 target attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLAreaElement_target(kde_HTMLAreaElement* instPointer);

/** *
 see @ref target
     
*/
void kde_HTMLAreaElement_setTarget(kde_HTMLAreaElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
