/***************************************************************************
                            kde_HTMLBodyElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLBODYELEMENT
#define KDE_HTMLBODYELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 The HTML document body. This element is always present in the DOM
 API, even if the tags are not present in the source document. See
 the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#edef-BODY">
 BODY element definition </a> in HTML 4.0.

 
 @short *
 The HTML document body.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLBodyElement * kde_new_HTMLBodyElement();
kde_HTMLBodyElement * kde_new_HTMLBodyElement1(kde_HTMLBodyElement* other);
kde_HTMLBodyElement * kde_new_HTMLBodyElement2(kde_DOMNode* other);
void kde_del_HTMLBodyElement( kde_HTMLBodyElement* p );

/** *
 Color of active links (after mouse-button down, but before
 mouse-button up). See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-alink">
 alink attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_aLink(kde_HTMLBodyElement* instPointer);

/** *
 see @ref aLink
     
*/
void kde_HTMLBodyElement_setALink(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

/** *
 URI of the background texture tile image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-background">
 background attribute definition </a> in HTML 4.0. This
 attribute is deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_background(kde_HTMLBodyElement* instPointer);

/** *
 see @ref background
     
*/
void kde_HTMLBodyElement_setBackground(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

/** *
 Document background color. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-bgcolor">
 bgcolor attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_bgColor(kde_HTMLBodyElement* instPointer);

/** *
 see @ref bgColor
     
*/
void kde_HTMLBodyElement_setBgColor(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

/** *
 Color of links that are not active and unvisited. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-link">
 link attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_link(kde_HTMLBodyElement* instPointer);

/** *
 see @ref link
     
*/
void kde_HTMLBodyElement_setLink(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

/** *
 Document text color. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-text">
 text attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_text(kde_HTMLBodyElement* instPointer);

/** *
 see @ref text
     
*/
void kde_HTMLBodyElement_setText(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

/** *
 Color of links that have been visited by the user. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/global.html#adef-vlink">
 vlink attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLBodyElement_vLink(kde_HTMLBodyElement* instPointer);

/** *
 see @ref vLink
     
*/
void kde_HTMLBodyElement_setVLink(kde_HTMLBodyElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
