/***************************************************************************
                            kde_HTMLButtonElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLBUTTONELEMENT
#define KDE_HTMLBUTTONELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Push button. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#edef-BUTTON">
 BUTTON element definition </a> in HTML 4.0.

 
 @short *
 Push button.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLButtonElement * kde_new_HTMLButtonElement();
kde_HTMLButtonElement * kde_new_HTMLButtonElement1(kde_HTMLButtonElement* other);
kde_HTMLButtonElement * kde_new_HTMLButtonElement2(kde_DOMNode* other);
void kde_del_HTMLButtonElement( kde_HTMLButtonElement* p );

/** *
 Returns the <code> FORM </code> element containing this
 control. Returns null if this control is not within the context
 of a form.

     
*/
kde_HTMLFormElement* kde_HTMLButtonElement_form(kde_HTMLButtonElement* instPointer);

/** *
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLButtonElement_accessKey(kde_HTMLButtonElement* instPointer);

/** *
 see @ref accessKey
     
*/
void kde_HTMLButtonElement_setAccessKey(kde_HTMLButtonElement* instPointer,kde_DOMString* arg1);

/** *
 The control is unavailable in this context. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-disabled">
 disabled attribute definition </a> in HTML 4.0.

     
*/
int kde_HTMLButtonElement_disabled(kde_HTMLButtonElement* instPointer);

/** *
 see @ref disabled
     
*/
void kde_HTMLButtonElement_setDisabled(kde_HTMLButtonElement* instPointer,int arg1);

/** *
 Form control or object name when submitted with a form. See the
 <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-name-BUTTON">
 name attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLButtonElement_name(kde_HTMLButtonElement* instPointer);

/** *
 see @ref name
     
*/
void kde_HTMLButtonElement_setName(kde_HTMLButtonElement* instPointer,kde_DOMString* arg1);

/** *
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLButtonElement_tabIndex(kde_HTMLButtonElement* instPointer);

/** *
 see @ref tabIndex
     
*/
void kde_HTMLButtonElement_setTabIndex(kde_HTMLButtonElement* instPointer,long arg1);

/** *
 The type of button. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-type-BUTTON">
 type attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLButtonElement_type(kde_HTMLButtonElement* instPointer);

/** *
 The current form control value. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-value-BUTTON">
 value attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLButtonElement_value(kde_HTMLButtonElement* instPointer);

/** *
 see @ref value
     
*/
void kde_HTMLButtonElement_setValue(kde_HTMLButtonElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
