/***************************************************************************
                            kde_HTMLFrameSetElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLFRAMESETELEMENT
#define KDE_HTMLFRAMESETELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Create a grid of frames. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#edef-FRAMESET">
 FRAMESET element definition </a> in HTML 4.0.

 
 @short *
 Create a grid of frames.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLFrameSetElement * kde_new_HTMLFrameSetElement();
kde_HTMLFrameSetElement * kde_new_HTMLFrameSetElement1(kde_HTMLFrameSetElement* other);
kde_HTMLFrameSetElement * kde_new_HTMLFrameSetElement2(kde_DOMNode* other);
void kde_del_HTMLFrameSetElement( kde_HTMLFrameSetElement* p );

/** *
 The number of columns of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-cols-FRAMESET">
 cols attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLFrameSetElement_cols(kde_HTMLFrameSetElement* instPointer);

/** *
 see @ref cols
     
*/
void kde_HTMLFrameSetElement_setCols(kde_HTMLFrameSetElement* instPointer,kde_DOMString* arg1);

/** *
 The number of rows of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-rows-FRAMESET">
 rows attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLFrameSetElement_rows(kde_HTMLFrameSetElement* instPointer);

/** *
 see @ref rows
     
*/
void kde_HTMLFrameSetElement_setRows(kde_HTMLFrameSetElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
