/***************************************************************************
                            kde_HTMLHRElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLHRELEMENT
#define KDE_HTMLHRELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Create a horizontal rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#edef-HR">
 HR element definition </a> in HTML 4.0.

 
 @short *
 Create a horizontal rule.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLHRElement * kde_new_HTMLHRElement();
kde_HTMLHRElement * kde_new_HTMLHRElement1(kde_HTMLHRElement* other);
kde_HTMLHRElement * kde_new_HTMLHRElement2(kde_DOMNode* other);
void kde_del_HTMLHRElement( kde_HTMLHRElement* p );

/** *
 Align the rule on the page. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-align-HR">
 align attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLHRElement_align(kde_HTMLHRElement* instPointer);

/** *
 see @ref align
     
*/
void kde_HTMLHRElement_setAlign(kde_HTMLHRElement* instPointer,kde_DOMString* arg1);

/** *
 Indicates to the user agent that there should be no shading in
 the rendering of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-noshade">
 noshade attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
int kde_HTMLHRElement_noShade(kde_HTMLHRElement* instPointer);

/** *
 see @ref noShade
     
*/
void kde_HTMLHRElement_setNoShade(kde_HTMLHRElement* instPointer,int arg1);

/** *
 The height of the rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-size-HR">
 size attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLHRElement_size(kde_HTMLHRElement* instPointer);

/** *
 see @ref size
     
*/
void kde_HTMLHRElement_setSize(kde_HTMLHRElement* instPointer,kde_DOMString* arg1);

/** *
 The width of the rule. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-width-HR">
 width attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLHRElement_width(kde_HTMLHRElement* instPointer);

/** *
 see @ref width
     
*/
void kde_HTMLHRElement_setWidth(kde_HTMLHRElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
