/***************************************************************************
                            kde_HTMLIFrameElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLIFRAMEELEMENT
#define KDE_HTMLIFRAMEELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Inline subwindows. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#edef-IFRAME">
 IFRAME element definition </a> in HTML 4.0.

 
 @short *
 Inline subwindows.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLIFrameElement * kde_new_HTMLIFrameElement();
kde_HTMLIFrameElement * kde_new_HTMLIFrameElement1(kde_HTMLIFrameElement* other);
kde_HTMLIFrameElement * kde_new_HTMLIFrameElement2(kde_DOMNode* other);
void kde_del_HTMLIFrameElement( kde_HTMLIFrameElement* p );

/** *
 Aligns this object (vertically or horizontally) with respect to
 its surrounding text. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-align-IMG">
 align attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_align(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref align
     
*/
void kde_HTMLIFrameElement_setAlign(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Request frame borders. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-frameborder">
 frameborder attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_frameBorder(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref frameBorder
     
*/
void kde_HTMLIFrameElement_setFrameBorder(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Frame height. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-height-IFRAME">
 height attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_height(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref height
     
*/
void kde_HTMLIFrameElement_setHeight(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 URI designating a long description of this image or frame. See
 the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-longdesc-IFRAME">
 longdesc attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_longDesc(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref longDesc
     
*/
void kde_HTMLIFrameElement_setLongDesc(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Frame margin height, in pixels. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-marginheight">
 marginheight attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_marginHeight(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref marginHeight
     
*/
void kde_HTMLIFrameElement_setMarginHeight(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Frame margin width, in pixels. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-marginwidth">
 marginwidth attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_marginWidth(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref marginWidth
     
*/
void kde_HTMLIFrameElement_setMarginWidth(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 The frame name (object of the <code> target </code> attribute).
 See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-name-IFRAME">
 name attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_name(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref name
     
*/
void kde_HTMLIFrameElement_setName(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Specify whether or not the frame should have scrollbars. See
 the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-scrolling">
 scrolling attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_scrolling(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref scrolling
     
*/
void kde_HTMLIFrameElement_setScrolling(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 A URI designating the initial frame contents. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-src-FRAME">
 src attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_src(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref src
     
*/
void kde_HTMLIFrameElement_setSrc(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Frame width. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.html#adef-width-IFRAME">
 width attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLIFrameElement_width(kde_HTMLIFrameElement* instPointer);

/** *
 see @ref width
     
*/
void kde_HTMLIFrameElement_setWidth(kde_HTMLIFrameElement* instPointer,kde_DOMString* arg1);

/** *
 Introduced in DOM Level 2

 Returns the document this iframe contains, if there is any and
 it is available, a Null document otherwise. The attribute is
 read-only.

*/
kde_Document* kde_HTMLIFrameElement_contentDocument(kde_HTMLIFrameElement* instPointer);

#ifdef __cplusplus
}
#endif
#endif
