/***************************************************************************
                            kde_HTMLImageElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLIMAGEELEMENT
#define KDE_HTMLIMAGEELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Embedded image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#edef-IMG">
 IMG element definition </a> in HTML 4.0.

 
 @short *
 Embedded image.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLImageElement * kde_new_HTMLImageElement();
kde_HTMLImageElement * kde_new_HTMLImageElement1(kde_HTMLImageElement* other);
kde_HTMLImageElement * kde_new_HTMLImageElement2(kde_DOMNode* other);
void kde_del_HTMLImageElement( kde_HTMLImageElement* p );

/** *
 The name of the element (for backwards compatibility).

     
*/
kde_DOMString* kde_HTMLImageElement_name(kde_HTMLImageElement* instPointer);

/** *
 see @ref name
     
*/
void kde_HTMLImageElement_setName(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 Aligns this object (vertically or horizontally) with respect to
 its surrounding text. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-align-IMG">
 align attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLImageElement_align(kde_HTMLImageElement* instPointer);

/** *
 see @ref align
     
*/
void kde_HTMLImageElement_setAlign(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 Alternate text for user agents not rendering the normal content
 of this element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-alt">
 alt attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLImageElement_alt(kde_HTMLImageElement* instPointer);

/** *
 see @ref alt
     
*/
void kde_HTMLImageElement_setAlt(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 Width of border around image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-border-IMG">
 border attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
long kde_HTMLImageElement_border(kde_HTMLImageElement* instPointer);

/** *
 see @ref border
     
*/
void kde_HTMLImageElement_setBorder(kde_HTMLImageElement* instPointer,long arg1);

/** *
 Override height. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-height-IMG">
 height attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLImageElement_height(kde_HTMLImageElement* instPointer);

/** *
 see @ref height
     
*/
void kde_HTMLImageElement_setHeight(kde_HTMLImageElement* instPointer,long arg1);

/** *
 Horizontal space to the left and right of this image. See the
 <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-hspace">
 hspace attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
long kde_HTMLImageElement_hspace(kde_HTMLImageElement* instPointer);

/** *
 see @ref hspace
     
*/
void kde_HTMLImageElement_setHspace(kde_HTMLImageElement* instPointer,long arg1);

/** *
 Use server-side image map. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-ismap">
 ismap attribute definition </a> in HTML 4.0.

     
*/
int kde_HTMLImageElement_isMap(kde_HTMLImageElement* instPointer);

/** *
 see @ref isMap
     
*/
void kde_HTMLImageElement_setIsMap(kde_HTMLImageElement* instPointer,int arg1);

/** *
 URI designating a long description of this image or frame. See
 the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-longdesc-IMG">
 longdesc attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLImageElement_longDesc(kde_HTMLImageElement* instPointer);

/** *
 see @ref longDesc
     
*/
void kde_HTMLImageElement_setLongDesc(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 URI designating the source of this image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-src-IMG">
 src attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLImageElement_src(kde_HTMLImageElement* instPointer);

/** *
 see @ref src
     
*/
void kde_HTMLImageElement_setSrc(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 Use client-side image map. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-usemap">
 usemap attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLImageElement_useMap(kde_HTMLImageElement* instPointer);

/** *
 see @ref useMap
     
*/
void kde_HTMLImageElement_setUseMap(kde_HTMLImageElement* instPointer,kde_DOMString* arg1);

/** *
 Vertical space above and below this image. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-vspace">
 vspace attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
long kde_HTMLImageElement_vspace(kde_HTMLImageElement* instPointer);

/** *
 see @ref vspace
     
*/
void kde_HTMLImageElement_setVspace(kde_HTMLImageElement* instPointer,long arg1);

/** *
 Override width. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-width-IMG">
 width attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLImageElement_width(kde_HTMLImageElement* instPointer);

/** *
 see @ref width
     
*/
void kde_HTMLImageElement_setWidth(kde_HTMLImageElement* instPointer,long arg1);

#ifdef __cplusplus
}
#endif
#endif
