/***************************************************************************
                            kde_HTMLOListElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLOLISTELEMENT
#define KDE_HTMLOLISTELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Ordered list. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.html#edef-OL">
 OL element definition </a> in HTML 4.0.

 
 @short *
 Ordered list.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLOListElement * kde_new_HTMLOListElement();
kde_HTMLOListElement * kde_new_HTMLOListElement1(kde_HTMLOListElement* other);
kde_HTMLOListElement * kde_new_HTMLOListElement2(kde_DOMNode* other);
void kde_del_HTMLOListElement( kde_HTMLOListElement* p );

/** *
 Reduce spacing between list items. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.html#adef-compact">
 compact attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
int kde_HTMLOListElement_compact(kde_HTMLOListElement* instPointer);

/** *
 see @ref compact
     
*/
void kde_HTMLOListElement_setCompact(kde_HTMLOListElement* instPointer,int arg1);

/** *
 Starting sequence number. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.html#adef-start">
 start attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
long kde_HTMLOListElement_start(kde_HTMLOListElement* instPointer);

/** *
 see @ref start
     
*/
void kde_HTMLOListElement_setStart(kde_HTMLOListElement* instPointer,long arg1);

/** *
 Numbering style. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.html#adef-type-OL">
 type attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLOListElement_type(kde_HTMLOListElement* instPointer);

/** *
 see @ref type
     
*/
void kde_HTMLOListElement_setType(kde_HTMLOListElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
