/***************************************************************************
                            kde_HTMLParamElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLPARAMELEMENT
#define KDE_HTMLPARAMELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Parameters fed to the <code> OBJECT </code> element. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#edef-PARAM">
 PARAM element definition </a> in HTML 4.0.

 
 @short *
 Parameters fed to the <code> OBJECT </code> element.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLParamElement * kde_new_HTMLParamElement();
kde_HTMLParamElement * kde_new_HTMLParamElement1(kde_HTMLParamElement* other);
kde_HTMLParamElement * kde_new_HTMLParamElement2(kde_DOMNode* other);
void kde_del_HTMLParamElement( kde_HTMLParamElement* p );

/** *
 The name of a run-time parameter. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-name-PARAM">
 name attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLParamElement_name(kde_HTMLParamElement* instPointer);

/** *
 see @ref name
     
*/
void kde_HTMLParamElement_setName(kde_HTMLParamElement* instPointer,kde_DOMString* arg1);

/** *
 Content type for the <code> value </code> attribute when <code>
 valuetype </code> has the value "ref". See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-type-PARAM">
 type attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLParamElement_type(kde_HTMLParamElement* instPointer);

/** *
 see @ref type
     
*/
void kde_HTMLParamElement_setType(kde_HTMLParamElement* instPointer,kde_DOMString* arg1);

/** *
 The value of a run-time parameter. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-value-PARAM">
 value attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLParamElement_value(kde_HTMLParamElement* instPointer);

/** *
 see @ref value
     
*/
void kde_HTMLParamElement_setValue(kde_HTMLParamElement* instPointer,kde_DOMString* arg1);

/** *
 Information about the meaning of the <code> value </code>
 attribute value. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.html#adef-valuetype">
 valuetype attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLParamElement_valueType(kde_HTMLParamElement* instPointer);

/** *
 see @ref valueType
     
*/
void kde_HTMLParamElement_setValueType(kde_HTMLParamElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
