/***************************************************************************
                            kde_HTMLScriptElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLSCRIPTELEMENT
#define KDE_HTMLSCRIPTELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Script statements. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#edef-SCRIPT">
 SCRIPT element definition </a> in HTML 4.0.

 
 @short *
 Script statements.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLScriptElement * kde_new_HTMLScriptElement();
kde_HTMLScriptElement * kde_new_HTMLScriptElement1(kde_HTMLScriptElement* other);
kde_HTMLScriptElement * kde_new_HTMLScriptElement2(kde_DOMNode* other);
void kde_del_HTMLScriptElement( kde_HTMLScriptElement* p );

/** *
 The script content of the element.

     
*/
kde_DOMString* kde_HTMLScriptElement_text(kde_HTMLScriptElement* instPointer);

/** *
 see @ref text
     
*/
void kde_HTMLScriptElement_setText(kde_HTMLScriptElement* instPointer,kde_DOMString* arg1);

/** *
 Reserved for future use.

     
*/
kde_DOMString* kde_HTMLScriptElement_htmlFor(kde_HTMLScriptElement* instPointer);

/** *
 see @ref htmlFor
     
*/
void kde_HTMLScriptElement_setHtmlFor(kde_HTMLScriptElement* instPointer,kde_DOMString* arg1);

/** *
 Reserved for future use.

     
*/
kde_DOMString* kde_HTMLScriptElement_event(kde_HTMLScriptElement* instPointer);

/** *
 see @ref event
     
*/

/** *
 The character encoding of the linked resource. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.html#adef-charset">
 charset attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLScriptElement_charset(kde_HTMLScriptElement* instPointer);

/** *
 see @ref charset
     
*/
void kde_HTMLScriptElement_setCharset(kde_HTMLScriptElement* instPointer,kde_DOMString* arg1);

/** *
 Indicates that the user agent can defer processing of the
 script. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-defer">
 defer attribute definition </a> in HTML 4.0.

     
*/
int kde_HTMLScriptElement_defer(kde_HTMLScriptElement* instPointer);

/** *
 see @ref defer
     
*/
void kde_HTMLScriptElement_setDefer(kde_HTMLScriptElement* instPointer,int arg1);

/** *
 URI designating an external script. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-src-SCRIPT">
 src attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLScriptElement_src(kde_HTMLScriptElement* instPointer);

/** *
 see @ref src
     
*/
void kde_HTMLScriptElement_setSrc(kde_HTMLScriptElement* instPointer,kde_DOMString* arg1);

/** *
 The content type of the script language. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/scripts.html#adef-type-SCRIPT">
 type attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLScriptElement_type(kde_HTMLScriptElement* instPointer);

/** *
 see @ref type
     
*/
void kde_HTMLScriptElement_setType(kde_HTMLScriptElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
