/***************************************************************************
                            kde_HTMLTableColElement.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_HTMLTABLECOLELEMENT
#define KDE_HTMLTABLECOLELEMENT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Regroups the <code> COL </code> and <code> COLGROUP </code>
 elements. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#edef-COL">
 COL element definition </a> in HTML 4.0.

 
 @short *
 Regroups the <code> COL </code> and <code> COLGROUP </code>
 elements.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_HTMLTableColElement * kde_new_HTMLTableColElement();
kde_HTMLTableColElement * kde_new_HTMLTableColElement1(kde_HTMLTableColElement* other);
kde_HTMLTableColElement * kde_new_HTMLTableColElement2(kde_DOMNode* other);
void kde_del_HTMLTableColElement( kde_HTMLTableColElement* p );

/** *
 Horizontal alignment of cell data in column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-align-TD">
 align attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLTableColElement_align(kde_HTMLTableColElement* instPointer);

/** *
 see @ref align
     
*/
void kde_HTMLTableColElement_setAlign(kde_HTMLTableColElement* instPointer,kde_DOMString* arg1);

/** *
 Alignment character for cells in a column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-char">
 char attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLTableColElement_ch(kde_HTMLTableColElement* instPointer);

/** *
 see @ref ch
     
*/
void kde_HTMLTableColElement_setCh(kde_HTMLTableColElement* instPointer,kde_DOMString* arg1);

/** *
 Offset of alignment character. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-charoff">
 charoff attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLTableColElement_chOff(kde_HTMLTableColElement* instPointer);

/** *
 see @ref chOff
     
*/
void kde_HTMLTableColElement_setChOff(kde_HTMLTableColElement* instPointer,kde_DOMString* arg1);

/** *
 Indicates the number of columns in a group or affected by a
 grouping. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-span-COL">
 span attribute definition </a> in HTML 4.0.

     
*/
long kde_HTMLTableColElement_span(kde_HTMLTableColElement* instPointer);

/** *
 see @ref span
     
*/
void kde_HTMLTableColElement_setSpan(kde_HTMLTableColElement* instPointer,long arg1);

/** *
 Vertical alignment of cell data in column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-valign">
 valign attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLTableColElement_vAlign(kde_HTMLTableColElement* instPointer);

/** *
 see @ref vAlign
     
*/
void kde_HTMLTableColElement_setVAlign(kde_HTMLTableColElement* instPointer,kde_DOMString* arg1);

/** *
 Default column width. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-width-COL">
 width attribute definition </a> in HTML 4.0.

     
*/
kde_DOMString* kde_HTMLTableColElement_width(kde_HTMLTableColElement* instPointer);

/** *
 see @ref width
     
*/
void kde_HTMLTableColElement_setWidth(kde_HTMLTableColElement* instPointer,kde_DOMString* arg1);

#ifdef __cplusplus
}
#endif
#endif
