/***************************************************************************
                            kde_KAuthIcon.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KAUTHICON
#define KDE_KAUTHICON

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 This is the base class from which different authorization icon widget
 which actually do something should be derived.  You can use these
 widgets to show that the user has (or doesn't have) the ability to do
 something, and why that is.

 One of the most useful things you can do with this is connect
 @ref authChanged(bool) to @ref setEnabled(bool) for a widget to turn it on and
 off depending on the status of whatever it is you are monitoring.

 @author Preston Brown <pbrown@kde.org>
 
 @short ABC for authorization icon widgets.
*/
#ifdef __cplusplus
extern   "C" {
#endif
void kde_del_KAuthIcon( kde_KAuthIcon* p );
qt_QSize * kde_KAuthIcon_sizeHint(kde_KAuthIcon* instPointer);

/** *
 return the status of whatever is being monitored.
   
*/
int kde_KAuthIcon_status(kde_KAuthIcon* instPointer);

/** *
 Re-implement this method if you want the icon to update itself
 when something external has changed (i.e. a file on disk, uid/gid).
   
*/
void kde_KAuthIcon_updateStatus(kde_KAuthIcon* instPointer);

#ifdef __cplusplus
}
#endif
#endif
