/***************************************************************************
                            kde_KColorDrag.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KCOLORDRAG
#define KDE_KCOLORDRAG

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 A drag-and-drop object for colors. The according MIME type
 is set to application/x-color.

 See the Qt drag'n'drop documentation.
 
 @short *
 A drag-and-drop object for colors.
*/

/** *
 Constructs a color drag with a white color.
     
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KColorDrag * kde_new_KColorDrag(qt_QWidget * dragsource, char* name);

/** *
 Constructs a color drag with the color @p.
     
*/
kde_KColorDrag * kde_new_KColorDrag1(qt_QColor * col, qt_QWidget * dragsource, char* name);
void kde_del_KColorDrag( kde_KColorDrag* p );

/** *
 Sets the color of the drag to @p col.
     
*/
void kde_KColorDrag_setColor(kde_KColorDrag* instPointer,qt_QColor * col);

/** *
 Returns true if the MIME source @p e contains a color object.
     
*/
int kde_KColorDrag_canDecode( qt_QMimeSource* e);

/** *
 Decodes the MIME source @p e and puts the resulting color into @p col.
     
*/
int kde_KColorDrag_decode( qt_QMimeSource* e, qt_QColor * col);

/** *

     
*/
kde_KColorDrag* kde_KColorDrag_makeDrag( qt_QColor * arg1, qt_QWidget * dragsource);
void kde_KColorDrag_virtual_hook(kde_KColorDrag* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
