/***************************************************************************
                            kde_KCombiView.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KCOMBIVIEW
#define KDE_KCOMBIVIEW

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 This view is designed to combine two KFileViews into one widget, to show
 directories on the left side and files on the right side.

 Methods like selectedItems() to query status _only_ work on the right side,
 i.e. on the files.

 After creating the KCombiView, you need to supply the view shown in the
 right, (see @ref setRight()). Available KFileView implementations are
 @ref KFileIconView and @ref KFileDetailView.

 Most of the below methods are just implementations of the baseclass
 @ref KFileView, so look there for documentation.

 @short *
 This view is designed to combine two KFileViews into one widget, to show
 directories on the left side and files on the right side.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KCombiView * kde_new_KCombiView(qt_QWidget * parent, char* name);
void kde_del_KCombiView( kde_KCombiView* p );
qt_QWidget * kde_KCombiView_widget(kde_KCombiView* instPointer);
void kde_KCombiView_clearView(kde_KCombiView* instPointer);
void kde_KCombiView_updateView(kde_KCombiView* instPointer,int arg1);
void kde_KCombiView_updateView1(kde_KCombiView* instPointer,kde_KFileItem* arg1);
void kde_KCombiView_removeItem(kde_KCombiView* instPointer,kde_KFileItem* arg1);
void kde_KCombiView_listingCompleted(kde_KCombiView* instPointer);

/** *
 Sets the view to be shown in the right. You need to call this before
 doing anything else with this widget.
     
*/
void kde_KCombiView_setRight(kde_KCombiView* instPointer,kde_KFileView* view);
void kde_KCombiView_setSelectionMode(kde_KCombiView* instPointer,int sm);
void kde_KCombiView_setSelected(kde_KCombiView* instPointer,kde_KFileItem* arg1, int arg2);
int kde_KCombiView_isSelected(kde_KCombiView* instPointer,kde_KFileItem* arg1);
void kde_KCombiView_clearSelection(kde_KCombiView* instPointer);
void kde_KCombiView_selectAll(kde_KCombiView* instPointer);
void kde_KCombiView_invertSelection(kde_KCombiView* instPointer);
void kde_KCombiView_setCurrentItem(kde_KCombiView* instPointer,kde_KFileItem* arg1);
kde_KFileItem* kde_KCombiView_currentFileItem(kde_KCombiView* instPointer);
kde_KFileItem* kde_KCombiView_firstFileItem(kde_KCombiView* instPointer);
kde_KFileItem* kde_KCombiView_nextItem(kde_KCombiView* instPointer,kde_KFileItem* arg1);
kde_KFileItem* kde_KCombiView_prevItem(kde_KCombiView* instPointer,kde_KFileItem* arg1);
void kde_KCombiView_insertItem(kde_KCombiView* instPointer,kde_KFileItem* i);
void kde_KCombiView_clear(kde_KCombiView* instPointer);
void kde_KCombiView_setSorting(kde_KCombiView* instPointer,int sort);
void kde_KCombiView_ensureItemVisible(kde_KCombiView* instPointer,kde_KFileItem* arg1);
void kde_KCombiView_virtual_hook(kde_KCombiView* instPointer,int identifier, void* data);
void kde_KCombiView_slotSortingChanged(kde_KCombiView* instPointer,int arg1);

/** Casts a 'kde_KCombiView *' to a 'kde_KFileView*' */
kde_KFileView* kde_KCombiView_KFileView(kde_KCombiView* instPointer);

/** Casts a 'kde_KCombiView *' to a 'qt_QSplitter*' */
qt_QSplitter* kde_KCombiView_QSplitter(kde_KCombiView* instPointer);

#ifdef __cplusplus
}
#endif
#endif
