/***************************************************************************
                            kde_KDateTable.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KDATETABLE
#define KDE_KDATETABLE

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 Date selection table.
 This is a support class for the KDatePicker class.  It just
 draws the calender table without titles, but could theoretically
 be used as a standalone.

 When a date is selected by the user, it emits a signal:
 dateSelected(QDate)

 @author Tim Gilman, Mirko Boehm
 
 @version $Id: kde_KDateTable.h,v 1.5 2002/12/30 14:37:05 geiseri Exp $

 @short *
 Date selection table.
*/

/** *
 The constructor.
     
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KDateTable * kde_new_KDateTable(qt_QWidget * parent, qt_QDate * date, char* name, int f);

/** *
 Returns a recommended size for the widget.
 To save some time, the size of the largest used cell content is
 calculated in each paintCell() call, since all calculations have
 to be done there anyway. The size is stored in maxCell. The
 sizeHint() simply returns a multiple of maxCell.
     
*/
qt_QSize * kde_KDateTable_sizeHint(kde_KDateTable* instPointer);

/** *
 Set the font size of the date table.
     
*/
void kde_KDateTable_setFontSize(kde_KDateTable* instPointer,int size);

/** *
 Select and display this date.
     
*/
int kde_KDateTable_setDate(kde_KDateTable* instPointer,qt_QDate * arg1);
qt_QDate * kde_KDateTable_getDate(kde_KDateTable* instPointer);

/** *
 Paint a cell.
     
*/
void kde_KDateTable_paintCell(kde_KDateTable* instPointer,qt_QPainter * arg1, int arg2, int arg3);

/** *
 Handle the resize events.
     
*/

/** *
 React on mouse clicks that select a date.
     
*/
void kde_KDateTable_virtual_hook(kde_KDateTable* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
