/***************************************************************************
                            kde_KDockWidgetHeader.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KDOCKWIDGETHEADER
#define KDE_KDOCKWIDGETHEADER

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 The header (additional bar) for a @ref KDockWidget s (and member of the dockwidget class set).
 It have got the buttons located there. And it is for recording and reading the button states.
 More or less a minor helper class for the dockwidget class set.

 @author Max Judin (documentation: Falk Brettschneider).
 
 @short *
 The header (additional bar) for a @ref KDockWidget s (and member of the dockwidget class set).
*/

/** *
 Constructs this.

*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KDockWidgetHeader * kde_new_KDockWidgetHeader(kde_KDockWidget* parent, char* name);

/** *
 Destructs this.
   
*/
void kde_del_KDockWidgetHeader( kde_KDockWidgetHeader* p );

/** *
 Hides the close button and stay button when switching to toplevel or vice versa shows them.

*/
void kde_KDockWidgetHeader_setTopLevel(kde_KDockWidgetHeader* instPointer,int t);

/** *
 Sets the drag panel of this header.

*/
void kde_KDockWidgetHeader_setDragPanel(kde_KDockWidgetHeader* instPointer,kde_KDockWidgetHeaderDrag* nd);
int kde_KDockWidgetHeader_dragEnabled(kde_KDockWidgetHeader* instPointer);
void kde_KDockWidgetHeader_setDragEnabled(kde_KDockWidgetHeader* instPointer,int b);
void kde_KDockWidgetHeader_showUndockButton(kde_KDockWidgetHeader* instPointer,int show);

/** *
 Saves the current button state to a KDE config container object.

*/
void kde_KDockWidgetHeader_saveConfig(kde_KDockWidgetHeader* instPointer,kde_KConfig* c);

/** *
 Loads the current button state from a KDE config container object.

*/
void kde_KDockWidgetHeader_loadConfig(kde_KDockWidgetHeader* instPointer,kde_KConfig* arg1);

/** *
 the drag panel (double line)
   
*/
void kde_KDockWidgetHeader_virtual_hook(kde_KDockWidgetHeader* instPointer,int identifier, void* data);

/** *
 Sets dragging the dockwidget off when the stay button is pressed down and vice versa.
   
*/
void kde_KDockWidgetHeader_slotStayClicked(kde_KDockWidgetHeader* instPointer);

#ifdef __cplusplus
}
#endif
#endif
