/***************************************************************************
                            kde_KEMailSettings.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KEMAILSETTINGS
#define KDE_KEMAILSETTINGS

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 This is just a small class to facilitate accessing e-mail settings in 
 a sane way, and allowing any program to manage multiple e-mail 
 profiles effortlessly

 @author Alex Zepeda zipzippy@sonic.net

 @short *
 This is just a small class to facilitate accessing e-mail settings in 
 a sane way, and allowing any program to manage multiple e-mail 
 profiles effortlessly

*/
#define KEMAILSETTINGS_ClientProgram	0
#define KEMAILSETTINGS_ClientTerminal	1
#define KEMAILSETTINGS_RealName	2
#define KEMAILSETTINGS_EmailAddress	3
#define KEMAILSETTINGS_ReplyToAddress	4
#define KEMAILSETTINGS_Organization	5
#define KEMAILSETTINGS_OutServer	6
#define KEMAILSETTINGS_OutServerLogin	7
#define KEMAILSETTINGS_OutServerPass	8
#define KEMAILSETTINGS_OutServerType	9
#define KEMAILSETTINGS_OutServerCommand	10
#define KEMAILSETTINGS_OutServerTLS	11
#define KEMAILSETTINGS_InServer	12
#define KEMAILSETTINGS_InServerLogin	13
#define KEMAILSETTINGS_InServerPass	14
#define KEMAILSETTINGS_InServerType	15
#define KEMAILSETTINGS_InServerMBXType	16
#define KEMAILSETTINGS_InServerTLS	17
#define KEMAILSETTINGS_POP3	0
#define KEMAILSETTINGS_SMTP	1
#define KEMAILSETTINGS_OTHER	2

/** *
 Default constructor, just sets things up.

*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KEMailSettings * kde_new_KEMailSettings();

/** *
 Default destructor, nothing to see here.

*/
void kde_del_KEMailSettings( kde_KEMailSettings* p );

/** *
 List of profiles available.

*/
qt_QStringList* kde_KEMailSettings_profiles(kde_KEMailSettings* instPointer);

/** *

*/
qt_QString * kde_KEMailSettings_currentProfileName(kde_KEMailSettings* instPointer);

/** *
 Change the current profile.

*/
void kde_KEMailSettings_setProfile(kde_KEMailSettings* instPointer,qt_QString * arg1);

/** *

*/
qt_QString * kde_KEMailSettings_defaultProfileName(kde_KEMailSettings* instPointer);

/** *
 New default..

*/
void kde_KEMailSettings_setDefault(kde_KEMailSettings* instPointer,qt_QString * arg1);

/** *
 Get a "basic" setting, one that I've already thought of..

*/
qt_QString * kde_KEMailSettings_getSetting(kde_KEMailSettings* instPointer,int s);
void kde_KEMailSettings_setSetting(kde_KEMailSettings* instPointer,int s, qt_QString * v);

/** *
 Use this when trying to get at currently unimplemented settings
 such as POP3 authentication methods, or mail specific TLS settings
 or something I haven't already thought of.

*/
/* 
qt_QString * kde_KEMailSettings_getExtendedSetting(kde_KEMailSettings* instPointer,int e, qt_QString * s);
*/
/** *
 Use this when trying to get at currently unimplemented settings
 such as POP3 authentication methods, or mail specific TLS settings
 or something I haven't already thought of.

*/
/*
void kde_KEMailSettings_setExtendedSetting(kde_KEMailSettings* instPointer,int e, qt_QString * s, qt_QString * v);
*/
#ifdef __cplusplus
}
#endif
#endif
