/***************************************************************************
                            kde_KIconView.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KICONVIEW
#define KDE_KICONVIEW

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 This Widget extends the functionality of QIconView to honor the system
 wide settings for Single Click/Double Click mode, Auto Selection and
 Change Cursor over Link.

 There is a new signal executed(). It gets connected to either
 @ref QIconView::clicked() or @ref QIconView::doubleClicked() depending on the KDE
 wide Single Click/Double Click settings. It is strongly recomended that
 you use this signal instead of the above mentioned. This way you dont
 need to care about the current settings.
 If you want to get informed when the user selects something connect to the
 @ref QIconView::selectionChanged() signal.

 @short A variant of QIconView that honors KDE's system-wide settings.

*/
#define KICONVIEW_Execute	0
#define KICONVIEW_Select	1
#ifdef __cplusplus
extern   "C" {
#endif
kde_KIconView * kde_new_KIconView(qt_QWidget * parent, char* name, int f);
void kde_del_KIconView( kde_KIconView* p );

/** *
 Sets the mode to Execute or Select.

 Default is Execute.
   
*/
void kde_KIconView_setMode(kde_KIconView* instPointer,int m);

/** *

*/
int kde_KIconView_mode(kde_KIconView* instPointer);

/** *
 Reimplemented for internal purposes
   
*/
void kde_KIconView_setFont(kde_KIconView* instPointer,qt_QFont * arg1);
void kde_KIconView_emitExecute(kde_KIconView* instPointer,qt_QIconViewItem* item, qt_QPoint* pos);
void kde_KIconView_virtual_hook(kde_KIconView* instPointer,int identifier, void* data);
void kde_KIconView_slotOnItem(kde_KIconView* instPointer,qt_QIconViewItem* item);
void kde_KIconView_slotOnViewport(kde_KIconView* instPointer);
void kde_KIconView_slotSettingsChanged(kde_KIconView* instPointer,int arg1);

/** *
 Auto selection happend.
   
*/
void kde_KIconView_slotAutoSelect(kde_KIconView* instPointer);

#ifdef __cplusplus
}
#endif
#endif
