/***************************************************************************
                            kde_KIntValidator.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KINTVALIDATOR
#define KDE_KINTVALIDATOR

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
  @ref QValidator for integers.

  This can be used by @ref QLineEdit or subclass to provide validated
  text entry.  Can be provided with a base value (default is 10), to allow
  the proper entry of hexadecimal, octal, or any other base numeric data.

 @author Glen Parker <glenebob@nwlink.com>

 @version 0.0.1

 @short *
  @ref QValidator for integers.
*/

/** *
      Constuctor.  Also sets the base value.
    
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KIntValidator * kde_new_KIntValidator(qt_QWidget * parent, int base, char* name);

/** *
 Constructor.  Also sets the minimum, maximum, and numeric base values.
     
*/
kde_KIntValidator * kde_new_KIntValidator1(int bottom, int top, qt_QWidget * parent, int base, char* name);

/** *
 Destructs the validator.
     
*/
void kde_del_KIntValidator( kde_KIntValidator* p );

/** *
 Validates the text, and return the result.  Does not modify the parameters.
     
*/
int kde_KIntValidator_validate(kde_KIntValidator* instPointer,qt_QString * arg1, int arg2);

/** *
 Fixes the text if possible, providing a valid string.  The parameter may be modified.
     
*/
void kde_KIntValidator_fixup(kde_KIntValidator* instPointer,qt_QString * arg1);

/** *
 Sets the minimum and maximum values allowed.
     
*/
void kde_KIntValidator_setRange(kde_KIntValidator* instPointer,int bottom, int top);

/** *
 Sets the numeric base value.
     
*/
void kde_KIntValidator_setBase(kde_KIntValidator* instPointer,int base);

/** *
 Returns the current minimum value allowed.
     
*/
int kde_KIntValidator_bottom(kde_KIntValidator* instPointer);

/** *
 Returns the current maximum value allowed.
     
*/
int kde_KIntValidator_top(kde_KIntValidator* instPointer);

/** *
 Returns the current numeric base.
     
*/
int kde_KIntValidator_base(kde_KIntValidator* instPointer);

#ifdef __cplusplus
}
#endif
#endif
