/***************************************************************************
                            kde_KPasswordEdit.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KPASSWORDEDIT
#define KDE_KPASSWORDEDIT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*

 The widget uses the user's global "echo mode" setting.
 
 @author Geert Jansen <geertj@kde.org>

 @short A safe password input widget.

*/
#define KPASSWORDEDIT_OneStar	0
#define KPASSWORDEDIT_ThreeStars	1
#define KPASSWORDEDIT_NoEcho	2

/** *
 Constructs a password input widget using the user's global "echo mode" setting.
     
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KPasswordEdit * kde_new_KPasswordEdit(qt_QWidget * parent, char* name);

/** *
 Constructs a password input widget using echoMode as "echo mode".

*/
kde_KPasswordEdit * kde_new_KPasswordEdit1(int echoMode, qt_QWidget * parent, char* name);

/** *

 Creates a password input widget using echoMode as "echo mode".
     
*/
kde_KPasswordEdit * kde_new_KPasswordEdit2(qt_QWidget * parent, char* name, int echoMode);

/** *
 Destructs the widget.
     
*/
void kde_del_KPasswordEdit( kde_KPasswordEdit* p );

/** * 
 Returns the password. The memory is freed in the destructor
 so you should make a copy.
     
*/
char* kde_KPasswordEdit_password(kde_KPasswordEdit* instPointer);

/** *
 Erases the current password.
     
*/
void kde_KPasswordEdit_erase(kde_KPasswordEdit* instPointer);
int kde_KPasswordEdit_event(kde_KPasswordEdit* instPointer,qt_QEvent * e);

#ifdef __cplusplus
}
#endif
#endif
