/***************************************************************************
                            kde_KSessionManaged.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KSESSIONMANAGED
#define KDE_KSESSIONMANAGED

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
   Provides highlevel access to session management on a per-object
   base.

   KSessionManaged makes it possible to provide implementations for
   @ref QApplication::commitData() and @ref QApplication::saveState(), without
   subclassing KApplication. KMainWindow internally makes use of this.

   You don't need to do anything with this class when using
   KMainWindow. Instead, use @ref KMainWindow::saveProperties(),
   @ref KMainWindow::readProperties(), @ref KMainWindow::queryClose(),
   @ref KMainWindow::queryExit() and friends.

 @author Matthias Ettrich <ettrich@kde.org>
 
 @short Highlevel access to session management.

*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KSessionManaged * kde_new_KSessionManaged();
void kde_del_KSessionManaged( kde_KSessionManaged* p );

/** *
       See @ref QApplication::saveState() for documentation.

       This function is just a convenience version to avoid subclassing KApplication.

       Return true to indicate a successful state save or false to
       indicate a problem and to halt the shutdown process (will
       implicitly call sm.cancel() ).
     
*/
int kde_KSessionManaged_saveState(kde_KSessionManaged* instPointer,qt_QSessionManager* sm);

/** *
       See @ref QApplication::commitData() for documentation.

       This function is just a convenience version to avoid subclassing KApplication.

       Return true to indicate a successful commit of data or false to
       indicate a problem and to halt the shutdown process (will
       implicitly call sm.cancel() ).
     
*/
int kde_KSessionManaged_commitData(kde_KSessionManaged* instPointer,qt_QSessionManager* sm);
void kde_KSessionManaged_virtual_hook(kde_KSessionManaged* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
