/***************************************************************************
                            kde_KShellCompletion.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KSHELLCOMPLETION
#define KDE_KSHELLCOMPLETION

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 This class does shell-like completion of file names.
 A string passed to makeCompletion() will be interpreted as a shell 
 command line. Completion will be done on the last argument on the line. 
 Returned matches consist of the first arguments (uncompleted) plus the 
 completed last argument.

 @author David Smith <dsmith@algonet.se>

 @version $Id:
 
 @short Shell-like completion of file names.
*/

/** *
 Constructs a KShellCompletion object.
         
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KShellCompletion * kde_new_KShellCompletion();

/** *
 Finds completions to the given text.
 The first match is returned and emitted in the signal match() 
	 
*/
qt_QString * kde_KShellCompletion_makeCompletion(kde_KShellCompletion* instPointer,qt_QString * arg1);
void kde_KShellCompletion_postProcessMatch(kde_KShellCompletion* instPointer,qt_QString* match);
void kde_KShellCompletion_postProcessMatches(kde_KShellCompletion* instPointer,qt_QStringList* matches);
void kde_KShellCompletion_postProcessMatches1(kde_KShellCompletion* instPointer,kde_KCompletionMatches* matches);
void kde_KShellCompletion_virtual_hook(kde_KShellCompletion* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
