/***************************************************************************
                            kde_KSqueezedTextLabel.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KSQUEEZEDTEXTLABEL
#define KDE_KSQUEEZEDTEXTLABEL

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 A label class that squeezes its text into the label

 If the text is too long to fit into the label it is divided into
 remaining left and right parts which are separated by three dots.

 Example:
 http://www.kde.org/documentation/index.html could be squeezed to
 http://www.kde...ion/index.html

 
 @author Ronny Standtke <Ronny.Standtke@gmx.de>

 @version $Id: kde_KSqueezedTextLabel.h,v 1.5 2002/12/30 14:37:06 geiseri Exp $

 @short A replacement for QLabel that squeezes its text.
*/

/** *
 Default constructor.
   
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KSqueezedTextLabel * kde_new_KSqueezedTextLabel(qt_QWidget * parent, char* name);
kde_KSqueezedTextLabel * kde_new_KSqueezedTextLabel1(qt_QString * text, qt_QWidget * parent, char* name);
qt_QSize * kde_KSqueezedTextLabel_minimumSizeHint(kde_KSqueezedTextLabel* instPointer);
void kde_KSqueezedTextLabel_setText(kde_KSqueezedTextLabel* instPointer,qt_QString * arg1);

/** *
 used when widget is resized
   
*/

/** *
 does the dirty work
   
*/
void kde_KSqueezedTextLabel_squeezeTextToLabel(kde_KSqueezedTextLabel* instPointer);
void kde_KSqueezedTextLabel_virtual_hook(kde_KSqueezedTextLabel* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
