/***************************************************************************
                            kde_KTipDialog.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KTIPDIALOG
#define KDE_KTIPDIALOG

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 A Tip-of-the-Day dialog.

 This dialog class presents a tip-of-the-day.

 @author Matthias Hoelzer-Kluepfel <mhk@caldera.de>
 
 @short *
 A Tip-of-the-Day dialog.
*/

/** *
 Construct a tip dialog.

*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KTipDialog * kde_new_KTipDialog(kde_KTipDatabase* db, qt_QWidget * parent, char* name);

/** *
 Shows a tip.

 This static method is all that is needed to add a tip-of-the-day
 dialog to an application. It will pop up the dialog, unless the
 user has asked that the dialog does not pop up on startup.

 Note that you probably want an item in the help menu calling
 this method with force=true.

*/
void kde_KTipDialog_showTip( qt_QWidget * parent, qt_QString * tipFile, int force);

/** *
 Shows a tip.

 This methods calls showTip() with the applications main window as parent.

     
*/
void kde_KTipDialog_showTip1( qt_QString * tipFile, int force);

/** *
 Toggles the start behaviour.

 Normally, the user can disable the display of the tip in the dialog.
 This is just a way to change this setting from outside.
     
*/
void kde_KTipDialog_setShowOnStart( int show);
int kde_KTipDialog_eventFilter(kde_KTipDialog* instPointer,qt_QObject * arg1, qt_QEvent * arg2);
void kde_KTipDialog_virtual_hook(kde_KTipDialog* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
