/***************************************************************************
                            kde_KToolBarRadioGroup.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KTOOLBARRADIOGROUP
#define KDE_KTOOLBARRADIOGROUP

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 KToolBarRadioGroup is class for group of radio butons in toolbar.
 Take toggle buttons which you already inserted into toolbar,
 create KToolBarRadioGroup instance and add them here.
 All buttons will emit signals toggled (bool) (or you can
 use sitgnal @ref #toggled (int id) from toolbar). When one button is set
 down, all others are unset. All buttons emit signals - those who
 "go down" and those who "go up".

 @author Sven Radej <radej@kde.org>

 @short Class for group of radio butons in toolbar.
  
*/

/** *
 Constructor. Parent must be @ref KToolBar .
   
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KToolBarRadioGroup * kde_new_KToolBarRadioGroup(kde_KToolBar* _parent, char* _name);

/** *
 Destructor.
   
*/
void kde_del_KToolBarRadioGroup( kde_KToolBarRadioGroup* p );

/** *
 Adds button to group. Button cannot be unset by mouse clicks (you
 must press some other button tounset this one)
   
*/
void kde_KToolBarRadioGroup_addButton(kde_KToolBarRadioGroup* instPointer,int identifier);

/** *
 Removes button from group, making it again toggle button (i.e.
 You can unset it with mouse).
   
*/
void kde_KToolBarRadioGroup_removeButton(kde_KToolBarRadioGroup* instPointer,int identifier);

/** *
 Internal - nothing for you here.
   
*/
void kde_KToolBarRadioGroup_slotToggled(kde_KToolBarRadioGroup* instPointer,int arg1);

#ifdef __cplusplus
}
#endif
#endif
