/***************************************************************************
                            kde_KXMLGUIFactory.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_KXMLGUIFACTORY
#define KDE_KXMLGUIFACTORY

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 KXMLGUIFactory, together with @ref KXMLGUIClient objects, can be used to create
 a GUI of container widgets (like menus, toolbars, etc.) and container items
 (menu items, toolbar buttons, etc.) from an XML document and action objects.

 Each @ref KXMLGUIClient represents a part of the GUI, composed from containers and
 actions. KXMLGUIFactory takes care of building (with the help of a @ref KXMLGUIBuilder)
 and merging the GUI from an unlimited number of clients.

 Each client provides XML through a @ref QDomDocument and actions through a
 @ref KActionCollection . The XML document contains the rules for how to merge the
 GUI.

 KXMLGUIFactory processes the DOM tree provided by a client and plugs in the client's actions,
 according to the XML and the merging rules of previously inserted clients. Container widgets
 are built via a @ref KXMLGUIBuilder , which has to be provided with the KXMLGUIFactory constructor.
 
 @short *
 KXMLGUIFactory, together with @ref KXMLGUIClient objects, can be used to create
 a GUI of container widgets (like menus, toolbars, etc.
*/

/** *
 Constructs a KXMLGUIFactory. The provided @p builder @ref KXMLGUIBuilder will be called
 for creating and removing container widgets, when clients are added/removed from the GUI.

 Note that the ownership of the given KXMLGUIBuilder object won't be transferred to this
 KXMLGUIFactory, so you have to take care of deleting it properly.
   
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_KXMLGUIFactory * kde_new_KXMLGUIFactory(kde_KXMLGUIBuilder* builder, qt_QObject * parent, char* name);

/** *
 Destructor
   
*/
void kde_del_KXMLGUIFactory( kde_KXMLGUIFactory* p );

/** *
 Creates the GUI described by the QDomDocument of the client,
 using the client's actions, and merges it with the previously
 created GUI.
 This also means that the order in which clients are added to the factory
 is relevant; assuming that your application supports plugins, you should
 first add your application to the factory and then the plugin, so that the
 plugin's UI is merged into the UI of your application, and not the other
 way round.
   
*/
void kde_KXMLGUIFactory_addClient(kde_KXMLGUIFactory* instPointer,kde_KXMLGUIClient* client);

/** *
 Removes the GUI described by the client, by unplugging all
 provided actions and removing all owned containers (and storing
 container state information in the given client)
   
*/
void kde_KXMLGUIFactory_removeClient(kde_KXMLGUIFactory* instPointer,kde_KXMLGUIClient* client);
void kde_KXMLGUIFactory_unplugActionList(kde_KXMLGUIFactory* instPointer,kde_KXMLGUIClient* client, qt_QString * name);

/** *
 Use this method to get access to a container widget with the name specified with @p containerName
 and which is owned by the @p client. The container name is specified with a "name" attribute in the
 XML document.

 This function is particularly useful for getting hold of a popupmenu defined in an XMLUI file.
 For instance:
 QPopupMenu *popup = static_cast<QPopupMenu*>(factory()->container("my_popup",this))
 where "my_popup" is the name of the menu in the XMLUI file, and
 "this" is XMLGUIClient which owns the popupmenu (e.g. the mainwindow, or the part, or the plugin...)

 This method may return 0L if no container with the given name exists or is not owned by the client.
   
*/
qt_QWidget * kde_KXMLGUIFactory_container(kde_KXMLGUIFactory* instPointer,qt_QString * containerName, kde_KXMLGUIClient* client, int useTagName);

/** *
 Use this method to free all memory allocated by the KXMLGUIFactory. This deletes the internal node
 tree and therefore resets the internal state of the class. Please note that the actual GUI is
 NOT touched at all, meaning no containers are deleted nor any actions unplugged. That is
 something you have to do on your own. So use this method only if you know what you are doing :-)

 (also note that this will call @ref KXMLGUIClient::setFactory( 0L ) for all inserted clients)
   
*/
void kde_KXMLGUIFactory_reset(kde_KXMLGUIFactory* instPointer);

/** *
 Use this method to free all memory allocated by the KXMLGUIFactory for a specific container,
 including all child containers and actions. This deletes the internal node subtree for the
 specified container. The actual GUI is not touched, no containers are deleted or any actions
 unplugged. Use this method only if you know what you are doing :-)

 (also note that this will call @ref KXMLGUIClient::setFactory( 0L ) for all clients of the
 container)
   
*/
void kde_KXMLGUIFactory_resetContainer(kde_KXMLGUIFactory* instPointer,qt_QString * containerName, int useTagName);
qt_QString * kde_KXMLGUIFactory_readConfigFile( qt_QString * filename, int never_null, kde_KInstance* instance);
qt_QString * kde_KXMLGUIFactory_readConfigFile1( qt_QString * filename, kde_KInstance* instance);
int kde_KXMLGUIFactory_saveConfigFile( qt_QDomDocument* doc, qt_QString * filename, kde_KInstance* instance);
qt_QString * kde_KXMLGUIFactory_documentToXML( qt_QDomDocument* doc);
qt_QString * kde_KXMLGUIFactory_elementToXML( qt_QDomElement* elem);

/** *
 Removes all QDomComment objects from the specified node and all its children.
   
*/
void kde_KXMLGUIFactory_removeDOMComments( qt_QDomNode* node);
void kde_KXMLGUIFactory_virtual_hook(kde_KXMLGUIFactory* instPointer,int identifier, void* data);

#ifdef __cplusplus
}
#endif
#endif
