/***************************************************************************
                            kde_ProcessingInstruction.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_PROCESSINGINSTRUCTION
#define KDE_PROCESSINGINSTRUCTION

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 The <code> ProcessingInstruction </code> interface represents a
 &quot;processing instruction&quot;, used in XML as a way to keep
 processor-specific information in the text of the document.

 
 @short *
 The <code> ProcessingInstruction </code> interface represents a
 &quot;processing instruction&quot;, used in XML as a way to keep
 processor-specific information in the text of the document.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_ProcessingInstruction * kde_new_ProcessingInstruction();
kde_ProcessingInstruction * kde_new_ProcessingInstruction1(kde_ProcessingInstruction* other);
kde_ProcessingInstruction * kde_new_ProcessingInstruction2(kde_DOMNode* other);
void kde_del_ProcessingInstruction( kde_ProcessingInstruction* p );

/** *
 The target of this processing instruction. XML defines this as
 being the first token following the markup that begins the
 processing instruction.

     
*/
kde_DOMString* kde_ProcessingInstruction_target(kde_ProcessingInstruction* instPointer);

/** *
 The content of this processing instruction. This is from the
 first non white space character after the target to the
 character immediately preceding the <code> ?&gt; </code> .

     
*/
kde_DOMString* kde_ProcessingInstruction_data(kde_ProcessingInstruction* instPointer);

/** *
 see @ref data

     
*/
void kde_ProcessingInstruction_setData(kde_ProcessingInstruction* instPointer,kde_DOMString* arg1);

/** *
 Introduced in DOM Level 2
 This method is from the LinkStyle interface

 The style sheet.
     
*/
kde_StyleSheet* kde_ProcessingInstruction_sheet(kde_ProcessingInstruction* instPointer);

#ifdef __cplusplus
}
#endif
#endif
