/***************************************************************************
                            kde_Rect.h -  description
                             -------------------
    begin                : Sun Nov 24 16:54:36 2002
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Sun Nov 24 16:54:36 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KDE_RECT
#define KDE_RECT

#include <qtc/qtc_types.h>

#include <kdec/kde_types.h>

/**
*
 The <code> Rect </code> interface is used to represent any <a
 href="http://www.w3.org/TR/REC-CSS2/visufx.html#value-def-shape">
 rect </a> value. This interface reflects the values in the
 underlying style property. Hence, modifications made through this
 interface modify the style property.

 
 @short *
 The <code> Rect </code> interface is used to represent any <a
 href="http://www.
*/
#ifdef __cplusplus
extern   "C" {
#endif
kde_Rect * kde_new_Rect();
kde_Rect * kde_new_Rect1(kde_Rect* other);
void kde_del_Rect( kde_Rect* p );

/** *
 This attribute is used for the top of the rect.

     
*/
kde_CSSPrimitiveValue* kde_Rect_top(kde_Rect* instPointer);

/** *
 This attribute is used for the right of the rect.

     
*/
kde_CSSPrimitiveValue* kde_Rect_right(kde_Rect* instPointer);

/** *
 This attribute is used for the bottom of the rect.

     
*/
kde_CSSPrimitiveValue* kde_Rect_bottom(kde_Rect* instPointer);

/** *
 This attribute is used for the left of the rect.

     
*/
kde_CSSPrimitiveValue* kde_Rect_left(kde_Rect* instPointer);

/** *

 not part of the DOM
     
*/
int kde_Rect_isNull(kde_Rect* instPointer);

#ifdef __cplusplus
}
#endif
#endif
