//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QWidget;

/**

 This is a dialog used to customize or configure toolbars.
 This dialog only works if your application uses the XML UI
 framework for creating menus and toolbars.  It depends on the XML
 files to describe the toolbar layouts and it requires the actions
 to determine which buttons are active.
 Typically, you would include the KStdAction.configureToolbars()
 standard action in your application.  In your slot to this action,
 you would have something like so:
 <pre>
 KEditToolbar dlg(actionCollection());
 if (dlg.exec())
 {
   createGUI();
 }
 </pre>
 That code snippet also takes care of redrawing the menu and
 toolbars if you have made any changes.
 If you are using KMainWindow's settings methods (either save/apply manually
 or autoSaveSettings), you should write something like:
 <pre>
 void MyClass.slotConfigureToolbars()
 {
   saveMainWindowSettings( KGlobal.config(), "MainWindow" );
   KEditToolbar dlg(actionCollection());
   connect(&dlg,SIGNAL("newToolbarConfig()"),this,SLOT("slotNewToolbarConfig()"));
   dlg.exec();
 }
 void MyClass.slotNewToolbarConfig() // This is called when OK or Apply is clicked
 {
    ...if you use any action list, use plugActionList on each here...
    createGUI();
    applyMainWindowSettings( KGlobal.config(), "MainWindow" );
 }
 </pre>
 Note that the procedure is a bit different for KParts applications.
 In this case, you need only pass along a pointer to your
 application's KXMLGUIFactory object.  The editor will take care of
 finding all of the action collections and xml files.  The editor
 aims to be semi-intelligent about where it assigns any
 modifications.  In other words, it will not write out part specific
 changes to your shell's xml file.
 An example would be:
 <pre>
 saveMainWindowSettings( KGlobal.config(), "MainWindow" );
 KEditToolbar dlg(factory());
 connect(&dlg,SIGNAL("newToolbarConfig()"),this,SLOT("slotNewToolbarConfig()"));
 dlg.exec();
 void MyClass.slotNewToolbarConfig() // This is called when OK or Apply is clicked
 {
    ...if you use any action list, use plugActionList on each here...
    // Do NOT call createGUI()!
    applyMainWindowSettings( KGlobal.config(), "MainWindow" );
 }
 </pre>
 See {@link KEditToolbarSignals} for signals emitted by KEditToolbar
		@author Kurt Granroth <granroth@kde.org>

		@version  kedittoolbar.h,v 1.36 2003/08/17 19:24:45 coolo
 
		@short A dialog used to customize or configure toolbars.

*/
public class KEditToolbar extends KDialogBase  {
	protected KEditToolbar(Class dummy){super((Class) null);}
	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Constructor for apps that do not use components.
			 This is the
		 only entry point to this class.  You <b>must</b> pass along your
		 collection of actions (some of which appear in your toolbars).
		 The other two parameters are optional.
			 The second parameter, xmlfile(), is the name (absolute or
		 relative) of your application's UI resource file.  If it is
		 left blank, then the resource file: share/apps/appname/appnameui.rc
		 is used.  This is the same resource file that is used by the
		 default createGUI() function in KMainWindow so you're usually
		 pretty safe in leaving it blank.
			 The third parameter, global(), controls whether or not the
		 global resource file is used.  If this is <code>true</code>, then you may
		 edit all of the actions in your toolbars -- global ones and
		 local one.  If it is <code>false</code>, then you may edit only your
		 application's entries.  The only time you should set this to
		 false is if your application does not use the global resource
		 file at all (very rare).
			@param collection The collection of actions to work on.
			@param xmlfile The application's local resource file.
			@param global If <code>true</code>, then the global resource file will also
		               be parsed.
			@param parent The parent of the dialog.
			@param name An internal name.
		   		@short    Constructor for apps that do not use components.
	*/
	public KEditToolbar(KActionCollection collection, String xmlfile, boolean global, QWidget parent, String name) {
		super((Class) null);
		newKEditToolbar(collection,xmlfile,global,parent,name);
	}
	private native void newKEditToolbar(KActionCollection collection, String xmlfile, boolean global, QWidget parent, String name);
	public KEditToolbar(KActionCollection collection, String xmlfile, boolean global, QWidget parent) {
		super((Class) null);
		newKEditToolbar(collection,xmlfile,global,parent);
	}
	private native void newKEditToolbar(KActionCollection collection, String xmlfile, boolean global, QWidget parent);
	public KEditToolbar(KActionCollection collection, String xmlfile, boolean global) {
		super((Class) null);
		newKEditToolbar(collection,xmlfile,global);
	}
	private native void newKEditToolbar(KActionCollection collection, String xmlfile, boolean global);
	public KEditToolbar(KActionCollection collection, String xmlfile) {
		super((Class) null);
		newKEditToolbar(collection,xmlfile);
	}
	private native void newKEditToolbar(KActionCollection collection, String xmlfile);
	public KEditToolbar(KActionCollection collection) {
		super((Class) null);
		newKEditToolbar(collection);
	}
	private native void newKEditToolbar(KActionCollection collection);
	public KEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global, QWidget parent, String name) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,collection,xmlfile,global,parent,name);
	}
	private native void newKEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global, QWidget parent, String name);
	public KEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global, QWidget parent) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,collection,xmlfile,global,parent);
	}
	private native void newKEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global, QWidget parent);
	public KEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,collection,xmlfile,global);
	}
	private native void newKEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile, boolean global);
	public KEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,collection,xmlfile);
	}
	private native void newKEditToolbar(String defaultToolbar, KActionCollection collection, String xmlfile);
	public KEditToolbar(String defaultToolbar, KActionCollection collection) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,collection);
	}
	private native void newKEditToolbar(String defaultToolbar, KActionCollection collection);
	/**	
		 Constructor for KParts based apps.
			 The main parameter, factory(), is a pointer to the
		 XML GUI factory object for your application.  It contains a list
		 of all of the GUI clients (along with the action collections and
		 xml files) and the toolbar editor uses that.
			 Use this like so:
		 <pre>
		 KEditToolbar edit(factory());
		 if ( edit.exec() )
		 ...
		 </pre>
			@param factory Your application's factory object
			@param parent The usual parent for the dialog.
			@param name An internal name.
			 Some people seem tempted to use this also in non-KParts apps, using KMainWindow.guiFactory().
		 This works, but only _if_ setting conserveMemory to false when calling
		 KMainWindow.createGUI()! If not, use the other KEditToolbar constructor.
		   		@short    Constructor for KParts based apps.
	*/
	public KEditToolbar(KXMLGUIFactory factory, QWidget parent, String name) {
		super((Class) null);
		newKEditToolbar(factory,parent,name);
	}
	private native void newKEditToolbar(KXMLGUIFactory factory, QWidget parent, String name);
	public KEditToolbar(KXMLGUIFactory factory, QWidget parent) {
		super((Class) null);
		newKEditToolbar(factory,parent);
	}
	private native void newKEditToolbar(KXMLGUIFactory factory, QWidget parent);
	public KEditToolbar(KXMLGUIFactory factory) {
		super((Class) null);
		newKEditToolbar(factory);
	}
	private native void newKEditToolbar(KXMLGUIFactory factory);
	public KEditToolbar(String defaultToolbar, KXMLGUIFactory factory, QWidget parent, String name) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,factory,parent,name);
	}
	private native void newKEditToolbar(String defaultToolbar, KXMLGUIFactory factory, QWidget parent, String name);
	public KEditToolbar(String defaultToolbar, KXMLGUIFactory factory, QWidget parent) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,factory,parent);
	}
	private native void newKEditToolbar(String defaultToolbar, KXMLGUIFactory factory, QWidget parent);
	public KEditToolbar(String defaultToolbar, KXMLGUIFactory factory) {
		super((Class) null);
		newKEditToolbar(defaultToolbar,factory);
	}
	private native void newKEditToolbar(String defaultToolbar, KXMLGUIFactory factory);
	/**	
		 Overridden in order to save any changes made to the toolbars
		   		@short    Overridden in order to save any changes made to the toolbars
	*/
	protected native void slotOk();
	/**	
		 idem
		   		@short    idem
	*/
	protected native void slotApply();
	/**	 should OK really save?
				@short   should OK really save?
	*/
	protected native void acceptOK(boolean b);
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
