//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import java.util.ArrayList;
import org.kde.qt.QValidator;
import org.kde.qt.QWidget;

/**

 The KInputDialog class provides a simple dialog to get a single value
 from the user. The value can be a string, a number (either an integer or
 a float) or an item from a list. This class is designed to be source
 compatible with QInputDialog.
 Five static convenience functions are provided: getText(), getInteger().
 getDouble(), getItem() and getItemList().
		@author Nadeem Hasan <nhasan@kde.org>
 
		@short    The KInputDialog class provides a simple dialog to get a single value  from the user.

*/
public class KInputDialog extends KDialogBase  {
	protected KInputDialog(Class dummy){super((Class) null);}
	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Static convenience function to get a string from the user.
			 caption is the text that is displayed in the title bar. label is the
		 text that appears as a label for the line edit. value is the initial
		 value of the 
		 line edit. ok will be set to true if user pressed Ok and false if
		 user pressed Cancel.
			 If you provide a validator, the Ok button is disabled as long as
		 the validator doesn't return Acceptable. If there is no validator,
		 the Ok button is enabled whenever the line edit isn't empty. If you
		 want to accept empty input, create a trivial QValidator that
		 always returns acceptable, e.g. QRegExpValidator with a regexp
		 of ".*".
			@param caption Caption of the dialog
			@param label Text of the label for the line edit
			@param value Initial value of the line edit
			@param ok This boolean would be set to true if user pressed Ok
			@param parent Parent of the dialog widget
			@param name Name of the dialog widget
			@param validator A {@link QValidator} to be associated with the line edit
			@param mask Mask associated with the line edit. See the
		                  documentation for {@link QLineEdit} about masks.
				@return String user entered if Ok was pressed, else a null string
     
		@short    Static convenience function to get a string from the user.
	*/
	public static native String getText(String caption, String label, String value, boolean[] ok, QWidget parent, String name, QValidator validator, String mask);
	public static native String getText(String caption, String label, String value, boolean[] ok, QWidget parent, String name, QValidator validator);
	public static native String getText(String caption, String label, String value, boolean[] ok, QWidget parent, String name);
	public static native String getText(String caption, String label, String value, boolean[] ok, QWidget parent);
	public static native String getText(String caption, String label, String value, boolean[] ok);
	public static native String getText(String caption, String label, String value);
	public static native String getText(String caption, String label);
	/**	
		 Static convenience function to let the user select an item from a
		 list. caption is the text that is displayed in the title bar.
		 label is the text that appears as the label for the list. list
		 is the string list which is inserted into the list, and current
		 is the number of the item which should be the selected item. If 
		 editable is true, the user can enter their own text.
			@param caption Caption of the dialog
			@param label Text of the label for the spin box
			@param list List of item for user to choose from
			@param current Index of the selected item
			@param editable If true, user can enter own text
			@param ok This boolean would be set to true if user pressed Ok
			@param parent Parent of the dialog widget
			@param name Name of the dialog widget
				@return Text of the selected item. If <code>editable</code> is true this can be
         a text entered by the user.
     
		@short    Static convenience function to let the user select an item from a  list.
	*/
	public static native String getItem(String caption, String label, String[] list, int current, boolean editable, boolean[] ok, QWidget parent, String name);
	public static native String getItem(String caption, String label, String[] list, int current, boolean editable, boolean[] ok, QWidget parent);
	public static native String getItem(String caption, String label, String[] list, int current, boolean editable, boolean[] ok);
	public static native String getItem(String caption, String label, String[] list, int current, boolean editable);
	public static native String getItem(String caption, String label, String[] list, int current);
	public static native String getItem(String caption, String label, String[] list);
	/**	
		 Static convenience function to let the user select one or more
		 items from a listbox. caption is the text that is displayed in the
		 title bar. label is the text that appears as the label for the listbox.
		 list is the string list which is inserted into the listbox, select
		 is the list of item(s) that should be the selected. If multiple is 
		 true, the user can select multiple items.
			@param caption Caption of the dialog
			@param label Text of the label for the spin box
			@param list List of item for user to choose from
			@param select List of item(s) that should be selected
			@param multiple If true, user can select multiple items
			@param ok This boolean would be set to true if user pressed Ok
			@param parent Parent of the dialog widget
			@param name Name of the dialog widget
				@return List of selected items if multiple is true, else currently
         selected item as an ArrayList
     
		@short    Static convenience function to let the user select one or more  items from a listbox.
	*/
	public static native ArrayList getItemList(String caption, String label, String[] list, String[] select, boolean multiple, boolean[] ok, QWidget parent, String name);
	public static native ArrayList getItemList(String caption, String label, String[] list, String[] select, boolean multiple, boolean[] ok, QWidget parent);
	public static native ArrayList getItemList(String caption, String label, String[] list, String[] select, boolean multiple, boolean[] ok);
	public static native ArrayList getItemList(String caption, String label, String[] list, String[] select, boolean multiple);
	public static native ArrayList getItemList(String caption, String label, String[] list, String[] select);
	public static native ArrayList getItemList(String caption, String label, String[] list);
	public static native ArrayList getItemList(String caption, String label);
}
