//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QPopupMenu;
import org.kde.qt.QWidget;
import org.kde.qt.QFrame;

/**

 Implement a panel applet.
 Panel applets

	<li>
	Are small applications living in the KDE panel.
	</li>
	
	<li>
	Are implemented as DSOs (Dynamic Shared Objects).
	</li>
	 Note: For security and stability reasons the panel won't load
 untrusted third party applets directly into its namespace but via an
 external wrapper process.
 The panel locates available applets by searching for applet desktop
 files in (ALL_KDEDIRS)/share/apps/kicker/applets. Every panel applet should
 install a desktop file there to be recognized by the panel.
 Besides standard keys like "Name", "Comment" and "Icon" there are
 two panel applet specific keys:
 <li><b>X-KDE-Library </b></li>
 Used by the panel to locate the applet DSO (Dynamic Shared Object)
 Example: X-KDE-Library=libexampleapplet
 <li><b>X-KDE-UniqueApplet </b></li>
 Similar to KApplication and KUniqueApplication there are
 two types of panel applets. Use unique applets when it makes no
 sence to run more than one instance of a applet in the panel. A
 good example for unique applets is the taskbar applet.  Use normal
 applets when you need instance specific configuration. An example
 is the koolclock applet where you might want to run two instances
 in your panel, one configured as analog clock, the other one as
 digital clock. X-KDE-UniqueApplet is a booleanean key which defaults
 to "false".  Example: X-KDE-UniqueApplet=true
 Back to panel applet DSOs, the following conventions are used for KDE:
 Name:    lib<appletname>applet.la
 LDFLAGS: -module -no-undefined
 To implement a panel applet it is not enough to write a class
 inheriting from KPanelApplet but you also have to provide a
 factory function in your DSO.  A sample factory function could look
 like this:
 <pre>
 extern "C"
 {
     KPanelApplet init(QWidget parent, String configFile)
     {
         KGlobal.locale().insertCatalogue("exampleapplet");
         return new ExampleApplet(configFile, KPanelApplet.Normal,
                       KPanelApplet.About | KPanelApplet.Help | KPanelApplet.Preferences,
                       parent, "exampleapplet");
     }
 }
 </pre>
 Note: Don't change the factory function signature or the panel will
 fail to load your applet.
 See {@link KPanelAppletSignals} for signals emitted by KPanelApplet
		@author Matthias Elter <elter@kde.org>

		@short KDE Panel Applet class.

*/
public class KPanelApplet extends QFrame  {
	protected KPanelApplet(Class dummy){super((Class) null);}
	/**	
		 This enum describes the type of the applet.
		     		@short    This enum describes the type of the applet.
	*/
	public static final int Normal = 0;
	public static final int Stretch = 1;

	/**	
		 This enum holds flags which can be ORed together to describe
		 which items the context menu over the applet handle contains.
		     		@short    This enum holds flags which can be ORed together to describe  which items the context menu over the applet handle contains.
	*/
	public static final int About = 1;
	public static final int Help = 2;
	public static final int Preferences = 4;
	public static final int ReportBug = 8;

	public static final int pLeft = 0;
	public static final int pRight = 1;
	public static final int pTop = 2;
	public static final int pBottom = 3;

	public static final int LeftTop = 0;
	public static final int Center = 1;
	public static final int RightBottom = 2;

	public static final int Up = 0;
	public static final int Down = 1;
	public static final int Left = 2;
	public static final int Right = 3;

	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Constructs a KPanelApplet just like any other widget.
			@param configFile The configFile handed over in the factory function.
			@param t The applet type().
			@param actions Standard RMB menu actions supported by the applet (see action() ).
			@param parent The pointer to the parent widget handed over in the factory function.
			@param name A Qt object name for your applet.
			@param f Window control flags
				@short    Constructs a KPanelApplet just like any other widget.
	*/
	public KPanelApplet(String configFile, int t, int actions, QWidget parent, String name, int f) {
		super((Class) null);
		newKPanelApplet(configFile,t,actions,parent,name,f);
	}
	private native void newKPanelApplet(String configFile, int t, int actions, QWidget parent, String name, int f);
	public KPanelApplet(String configFile, int t, int actions, QWidget parent, String name) {
		super((Class) null);
		newKPanelApplet(configFile,t,actions,parent,name);
	}
	private native void newKPanelApplet(String configFile, int t, int actions, QWidget parent, String name);
	public KPanelApplet(String configFile, int t, int actions, QWidget parent) {
		super((Class) null);
		newKPanelApplet(configFile,t,actions,parent);
	}
	private native void newKPanelApplet(String configFile, int t, int actions, QWidget parent);
	public KPanelApplet(String configFile, int t, int actions) {
		super((Class) null);
		newKPanelApplet(configFile,t,actions);
	}
	private native void newKPanelApplet(String configFile, int t, int actions);
	public KPanelApplet(String configFile, int t) {
		super((Class) null);
		newKPanelApplet(configFile,t);
	}
	private native void newKPanelApplet(String configFile, int t);
	public KPanelApplet(String configFile) {
		super((Class) null);
		newKPanelApplet(configFile);
	}
	private native void newKPanelApplet(String configFile);
	/**	
		 Returns a suggested width for a given height.
			 Every applet should reimplement this function.
			 Depending on the panel orientation the height (horizontal panel) or the
		 width (vertical panel) of the applets is fixed.
		 The exact values of the fixed size component depend on the panel size.
			 On a horizontal panel the applet height is fixed, the panel will
		 call widthForHeight(int height) with <code>height</code>
		 equal to 'the fixed applet height'
		 when laying out the applets.
			 The applet can now choose the other size component (width)
		 based on the given height.
			 The width you return is granted.
				@short    Returns a suggested width for a given height.
	*/
	public native int widthForHeight(int height);
	/**	
			 Every applet should reimplement this function.
			 Depending on the panel orientation the height (horizontal panel) or the
		 width (vertical panel) of the applets is fixed.
		 The exact values of the fixed size component depend on the panel size.
			 On a vertical panel the applet width is fixed, the panel will
		 call heightForWidth(int width) with <code>width</code>
		 equal to 'the fixed applet width'
		 when layint out the applets.
			 The applet can now choose the other size component (height)
		 based on the given width.
			 The height you return is granted.
				@return A suggested height for a given width.

		@short
	*/
	public native int heightForWidth(int width);
	/**	
		 Always use this KConfig object to save/load your applets configuration.
			 For unique applets this config object will write to a config file called
		 \<appletname\>rc in the users local KDE directory.
			 For normal applets this config object will write to a instance specific config file
		 called \<appletname\>\<instanceid\>rc in the users local KDE directory.
				@short    Always use this KConfig object to save/load your applets configuration.
	*/
	public native KConfig config();
	// KSharedConfig::Ptr sharedConfig(); >>>> NOT CONVERTED
	/**	
				@return Type indicating the applet's type.
 Type

		@short
	*/
	public native int type();
	/**	
				@return int indicating the supported RMB menu actions.
 Action

		@short
	*/
	public native int actions();
	/**	
		 Generic action dispatcher. Called  when the user selects an item
		 from the applets RMB menu.
			 Reimplement this function to handle actions.
			 For About, Help, Preferences and ReportBug, use the convenience handlers
		 ref about(), help(), preferences(), reportBug()
				@short    Generic action dispatcher.
	*/
	public native void action(int a);
	/**	
				@return the applet's custom menu, usually the same as the context menu, or 0 if none
 see setCustomMenu(QPopupMenu*)
     
		@short
	*/
	public native QPopupMenu customMenu();
	/**	
				@short
	*/
	public native void setPosition(int p);
	/**	
				@short
	*/
	public native void setAlignment(int a);
	/**	
		 Is called when the user selects "About" from the applet's RMB menu.
		 Reimplement this function to launch a about dialog.
			 Note that this is called only when your applet supports the About action.
		 See Action and KPanelApplet().
				@short    Is called when the user selects "About" from the applet's RMB menu.
	*/
	protected native void about();
	/**	
		 Is called when the user selects "Help" from the applet's RMB menu.
		 Reimplement this function to launch a manual or help page.
			 Note that this is called only when your applet supports the Help action.
		 See Action and KPanelApplet().
				@short    Is called when the user selects "Help" from the applet's RMB menu.
	*/
	protected native void help();
	/**	
		 Is called when the user selects "Preferences" from the applet's RMB menu.
		 Reimplement this function to launch a preferences dialog or kcontrol module.
			 Note that this is called only when your applet supports the preferences action.
		 See Action and KPanelApplet().
				@short    Is called when the user selects "Preferences" from the applet's RMB menu.
	*/
	protected native void preferences();
	/**	
		 Is called when the user selects "Report bug" from the applet's RMB menu.
		 Reimplement this function to launch a bug reporting dialog.
			 Note that this is called only when your applet supports the ReportBug
		 action.
		 See Action and KPanelApplet()
				@short    Is called when the user selects "Report bug" from the applet's RMB menu.
	*/
	protected native void reportBug();
	/**	
				@return the applet's orientation. (horizontal or vertical)

		@short
	*/
	protected native int orientation();
	/**	
				@return the applet's position. (top, left, bottom, or right)

		@short
	*/
	protected native int position();
	/**	
				@return the applet's alignment. (top/left, center, or bottom/right)

		@short
	*/
	protected native int alignment();
	/**	
		 The panel on which this applet resides has changed its position.
		 Reimplement this change handler in order to adjust the look of your
		 applet.
				@short    The panel on which this applet resides has changed its position.
	*/
	protected native void positionChange(int p);
	/**	
		 The panel on which this applet resides has changed its alignment.
		 Reimplement this change handler in order to adjust the look of your
		 applet.
				@short    The panel on which this applet resides has changed its alignment.
	*/
	protected native void alignmentChange(int arg1);
	/**	
		 Use this method to set the custom menu for this applet so that it can be shown
		 in the applet handle menu and other appropriate places that the applet many not itself
		 be aware of. The applet itself is still responsible for deleting and managing the
		 the menu.
			 If the menu is deleted during the life of the applet, be sure to call this method again
		 with the new menu (or 0) to avoid crashes
		     		@short    Use this method to set the custom menu for this applet so that it can be shown  in the applet handle menu and other appropriate places that the applet many not itself  be aware of.
	*/
	protected native void setCustomMenu(QPopupMenu arg1);
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
