//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QListBox;
import org.kde.qt.QtSupport;
import org.kde.qt.QPixmap;
import org.kde.qt.QSize;
import org.kde.qt.QPainter;
import org.kde.qt.QListBoxPixmap;

/**

 An item to be used in KURLBar / KURLBarListBox. All the properties
 (url, icon, description, tooltip) can be changed dynamically.
		@author Carsten Pfeiffer <pfeiffer@kde.org>

		@short    An item to be used in KURLBar / KURLBarListBox.
		@see KURLBar
		@see KURLBarListBox

*/
public class KURLBarItem extends QListBoxPixmap  {
	protected KURLBarItem(Class dummy){super((Class) null);}
	/**	
		 Creates a KURLBarItem to be used in the <code>parent</code> KURLBar. You need
		 to insert the item into the listbox manually, if you don't use
		 KURLBar.insertItem().
			 If description is empty, it will try to use the filename/directory
		 of <code>url</code>, which will be shown as text of the item.
		 <code>url</code> will be used as tooltip, unless you set a different tip with
		 setToolTip().
		 <code>persistent</code> specifies whether this item is a persistent item or a
		 dynamic item, that is not saved with KURLBar.writeConfig().
				@short    Creates a KURLBarItem to be used in the <code>parent</code> KURLBar.
	*/
	public KURLBarItem(KURLBar parent, KURL url, boolean persistent, String description, String icon, int group) {
		super((Class) null);
		newKURLBarItem(parent,url,persistent,description,icon,group);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, boolean persistent, String description, String icon, int group);
	public KURLBarItem(KURLBar parent, KURL url, boolean persistent, String description, String icon) {
		super((Class) null);
		newKURLBarItem(parent,url,persistent,description,icon);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, boolean persistent, String description, String icon);
	public KURLBarItem(KURLBar parent, KURL url, boolean persistent, String description) {
		super((Class) null);
		newKURLBarItem(parent,url,persistent,description);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, boolean persistent, String description);
	public KURLBarItem(KURLBar parent, KURL url, boolean persistent) {
		super((Class) null);
		newKURLBarItem(parent,url,persistent);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, boolean persistent);
	/**	
		 Creates a persistent KURLBarItem to be used in the <code>parent</code> KURLBar. You need
		 to insert the item into the listbox manually, if you don't use
		 KURLBar.insertItem().
			 If description is empty, it will try to use the filename/directory
		 of <code>url</code>, which will be shown as text of the item.
		 <code>url</code> will be used as tooltip, unless you set a different tip with
		 setToolTip().
		 <code>persistent</code> specifies whether this item is a persistent item or a
		 dynamic item, that is not saved with KURLBar.writeConfig().
		     		@short    Creates a persistent KURLBarItem to be used in the <code>parent</code> KURLBar.
	*/
	public KURLBarItem(KURLBar parent, KURL url, String description, String icon, int group) {
		super((Class) null);
		newKURLBarItem(parent,url,description,icon,group);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, String description, String icon, int group);
	public KURLBarItem(KURLBar parent, KURL url, String description, String icon) {
		super((Class) null);
		newKURLBarItem(parent,url,description,icon);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, String description, String icon);
	public KURLBarItem(KURLBar parent, KURL url, String description) {
		super((Class) null);
		newKURLBarItem(parent,url,description);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url, String description);
	public KURLBarItem(KURLBar parent, KURL url) {
		super((Class) null);
		newKURLBarItem(parent,url);
	}
	private native void newKURLBarItem(KURLBar parent, KURL url);
	/**	
		 Sets <code>url</code> for this item. Also updates the visible text to the
		 filename/directory of the url, if no description is set.
				@short    Sets <code>url</code> for this item.
		@see #url
	*/
	public native void setURL(KURL url);
	/**	
		 <code>sets</code> the icon for this item. See KIconLoader for a description
		 of the icon groups.
				@short    <code>sets</code> the icon for this item.
		@see #icon
	*/
	public native void setIcon(String icon, int group);
	public native void setIcon(String icon);
	/**	
		 Sets the description of this item that will be shown as item-text.
				@short    Sets the description of this item that will be shown as item-text.
		@see #description
	*/
	public native void setDescription(String desc);
	/**	
		 Sets a tooltip to be used for this item.
				@short    Sets a tooltip to be used for this item.
		@see #toolTip
	*/
	public native void setToolTip(String tip);
	/**	
		 returns the preferred size of this item
				@short    returns the preferred size of this item
	*/
	public native QSize sizeHint();
	/**	
		 returns the width of this item.
		     		@short    returns the width of this item.
	*/
	public native int width(QListBox arg1);
	/**	
		 returns the height of this item.
		     		@short    returns the height of this item.
	*/
	public native int height(QListBox arg1);
	/**	
		 returns the url of this item.
				@short    returns the url of this item.
		@see #setURL
	*/
	public native KURL url();
	/**	
		 returns the description of this item.
				@short    returns the description of this item.
		@see #setDescription
	*/
	public native String description();
	/**	
		 returns the icon of this item.
				@short    returns the icon of this item.
		@see #setIcon
	*/
	public native String icon();
	/**	
		 returns the tooltip of this item.
				@short    returns the tooltip of this item.
		@see #setToolTip
	*/
	public native String toolTip();
	/**	
		 returns the icon-group of this item (determines icon-effects).
				@short    returns the icon-group of this item (determines icon-effects).
		@see #setIcon
	*/
	public native int iconGroup();
	/**	
		 returns the pixmap  of this item.
		     		@short    returns the pixmap  of this item.
	*/
	public native QPixmap pixmap();
	/**	
		 Makes this item a local or global one. This has only an effect
		 on persistent items of course.
				@short    Makes this item a local or global one.
		@see #isPersistent
		@see #applicationLocal
	*/
	public native void setApplicationLocal(boolean local);
	/**	
		 returns whether this is a global item or a local one. KURLBar
		 can differentiate between global and local items (only for the current
		 application) for easy extensiblity.
				@short    returns whether this is a global item or a local one.
		@see #setApplicationLocal
	*/
	public native boolean applicationLocal();
	/**	
		 returns whether this item is persistent (via KURLBar.writeConfig()
		 and KURLBar.readConfig()) or not.
				@short    returns whether this item is persistent (via KURLBar.writeConfig()  and KURLBar.readConfig()) or not.
	*/
	public native boolean isPersistent();
	protected native void paint(QPainter p);
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
