//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QColor;
import org.kde.qt.QFont;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QPixmap;
import org.kde.qt.QMouseEvent;
import org.kde.qt.QCursor;
import org.kde.qt.QEvent;
import org.kde.qt.QWidget;
import org.kde.qt.QLabel;

/**

 KURLLabel is a drop-in replacement for QLabel that handles text
 in a fashion similar to how an HTML widget handles hyperlinks.  The
 text can be underlined (or not) and set to different colors.  It
 can also "glow" (cycle colors) when the mouse passes over it.
 KURLLabel also provides signals for several events, including
 the mouse leaving and entering the text area and all forms of
 mouse clicking.
 A typical usage would be something like so:
 <pre>
 KURLLabel address = new KURLLabel(this);
 address.setText("My homepage");
 address.setURL("http://www.home.com/~me");
 connect(address, SIGNAL("leftClickedURL(String)"),
                  SLOT("processMyURL(String)"));
 </pre>
 In this example, the text "My homepage" would be displayed
 as blue, underlined text.  When the mouse passed over it,
 it would "glow" red.  When the user clicks on the text, the
 signal leftClickedURL() would be emitted with "http://www.home.com/~me"
 as its argument.
 \image html kurllabel.png "KDE URL Label"
  See {@link KURLLabelSignals} for signals emitted by KURLLabel
		@author Peter Putzer <putzer@kde.org> (Rewrite)

		@version  kurllabel.h,v 1.28 2003/09/11 14:03:17 staikos

		@short A drop-in replacement for QLabel that displays hyperlinks.

*/
public class KURLLabel extends QLabel  {
	protected KURLLabel(Class dummy){super((Class) null);}
	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Default constructor.
			 Use setURL() and setText() or QListView.setPixmap()
		 to set the resp. properties.
		   		@short    Default constructor.
	*/
	public KURLLabel(QWidget parent, String name) {
		super((Class) null);
		newKURLLabel(parent,name);
	}
	private native void newKURLLabel(QWidget parent, String name);
	public KURLLabel(QWidget parent) {
		super((Class) null);
		newKURLLabel(parent);
	}
	private native void newKURLLabel(QWidget parent);
	public KURLLabel() {
		super((Class) null);
		newKURLLabel();
	}
	private native void newKURLLabel();
	/**	
		 Convenience constructor.
			@param url is the URL emitted when the label is clicked.
			@param text is the displayed string. If it's equal to null
		 the <code>url</code> will be used instead.
			@param parent Passed to lower level constructor
			@param name Passed to lower level constructor
			 <code>parent</code> and <code>name</code> are passed to QLabel, which in turn passes
		 them further down
		   		@short    Convenience constructor.
	*/
	public KURLLabel(String url, String text, QWidget parent, String name) {
		super((Class) null);
		newKURLLabel(url,text,parent,name);
	}
	private native void newKURLLabel(String url, String text, QWidget parent, String name);
	public KURLLabel(String url, String text, QWidget parent) {
		super((Class) null);
		newKURLLabel(url,text,parent);
	}
	private native void newKURLLabel(String url, String text, QWidget parent);
	public KURLLabel(String url, String text) {
		super((Class) null);
		newKURLLabel(url,text);
	}
	private native void newKURLLabel(String url, String text);
	public KURLLabel(String url) {
		super((Class) null);
		newKURLLabel(url);
	}
	private native void newKURLLabel(String url);
	/**	
		 Returns the URL.
		   		@short    Returns the URL.
	*/
	public native String url();
	/**	
		 Returns the current tooltip text.
		   		@short    Returns the current tooltip text.
	*/
	public native String tipText();
	/**	
				@return true if a tooltip will be displayed.

		@short   
		@see #setTipText
	*/
	public native boolean useTips();
	/**	
				@return true if the cursor will change while over the URL.

		@short   
		@see #setUseCursor
	*/
	public native boolean useCursor();
	/**	
		 When this is on, the text will switch to the selected
		 color whenever the mouse passes over it.
		   		@short    When this is on, the text will switch to the selected  color whenever the mouse passes over it.
	*/
	public native boolean isGlowEnabled();
	/**	
		 This feature is very similar to the "glow" feature in that the color of the
		 label switches to the selected color when the cursor passes
		 over it. In addition, underlining is turned on for as
		 long as the mouse is overhead. Note that if "glow" and
		 underlining are both already turned on, this feature
		 will have no visible effect.
		   		@short    This feature is very similar to the "glow" feature in that the color of the  label switches to the selected color when the cursor passes  over it.
	*/
	public native boolean isFloatEnabled();
	/**	
				@return the alternate pixmap (may be 0L if none was set).
   
		@short
	*/
	public native QPixmap altPixmap();
	/**	
		 Turns on or off the underlining.
			  When this is on, the
		 text will be underlined.  By default, it is <code>true.</code>
		   		@short    Turns on or off the underlining.
	*/
	public native void setUnderline(boolean on);
	public native void setUnderline();
	/**	
		 Sets the URL for this label to <code>url.</code>
				@short    Sets the URL for this label to <code>url.</code>
		@see #url
	*/
	public native void setURL(String url);
	/**	
		 Overridden for internal reasons; the API remains unaffected.
		   		@short    Overridden for internal reasons; the API remains unaffected.
	*/
	public native void setFont(QFont arg1);
	/**	
		 Turns on or off the tool tip feature.
			 When this is on, the URL will be displayed as a
		 tooltip whenever the mouse passes passes over it.
		 By default, it is <code>false.</code>
		   		@short    Turns on or off the tool tip feature.
	*/
	public native void setUseTips(boolean on);
	public native void setUseTips();
	/**	
		 Specifies what text to display when tooltips are turned on.
			 If this is not used, the tip will default to the URL.
				@short    Specifies what text to display when tooltips are turned on.
		@see #setUseTips
	*/
	public native void setTipText(String tip);
	/**	
		 Sets the highlight color.
			 This is the default foreground
		 color (non-selected).  By default, it is <code>blue.</code>
		   		@short    Sets the highlight color.
	*/
	public native void setHighlightedColor(QColor highcolor);
	/**	
		 This is an overloaded version for convenience.
				@short    This is an overloaded version for convenience.
		@see #setHighlightedColor
	*/
	public native void setHighlightedColor(String highcolor);
	/**	
		 Sets the selected color.
			 This is the color the text will change
		 to when either a mouse passes over it and "glow" mode is on or
		 when it is selected (clicked).  By default, it is <code>red.</code>
		   		@short    Sets the selected color.
	*/
	public native void setSelectedColor(QColor selcolor);
	/**	
		 This is an overloaded version for convenience.
				@short    This is an overloaded version for convenience.
		@see #setSelectedColor
	*/
	public native void setSelectedColor(String selcolor);
	/**	
		 Turns the custom cursor feature on or off.
			 When this is on, the cursor will change to a custom cursor
		 (default is a "pointing hand") whenever the cursor passes
		 over the label. By default, it is on.
			@param on whether a custom cursor should be displayed.
			@param cursor is the custom cursor. <code>null</code> indicates the default "hand cursor".
		   		@short    Turns the custom cursor feature on or off.
	*/
	public native void setUseCursor(boolean on, QCursor cursor);
	public native void setUseCursor(boolean on);
	/**	
		 Turns on or off the "glow" feature.
			 When this is on, the text will switch to the
		 selected color whenever the mouse
		 passes over it. By default, it is <code>true.</code>
		   		@short    Turns on or off the "glow" feature.
	*/
	public native void setGlow(boolean glow);
	public native void setGlow();
	/**	
		 Turns on or off the "float" feature.
			 This feature is very similar to the "glow" feature in
		 that the color of the label switches to the selected
		 color when the cursor passes over it. In addition,
		 underlining is turned on for as long as the mouse is overhead.
		 Note that if "glow" and underlining are both already turned
		 on, this feature will have no visible effect.
		 By default, it is <code>false.</code>
		   		@short    Turns on or off the "float" feature.
	*/
	public native void setFloat(boolean do_float);
	public native void setFloat();
	/**	
		 Sets the "alt" pixmap.
			 This pixmap will be displayed when the
		 cursor passes over the label.  The effect is similar to the
		 trick done with 'onMouseOver' in javascript.
				@short    Sets the "alt" pixmap.
		@see #altPixmap
	*/
	public native void setAltPixmap(QPixmap altPix);
	/**	
		 Overridden for internal reasons; the API remains unaffected.
		   		@short    Overridden for internal reasons; the API remains unaffected.
	*/
	protected native void mouseReleaseEvent(QMouseEvent arg1);
	/**	
		 Overridden for internal reasons; the API remains unaffected.
		   		@short    Overridden for internal reasons; the API remains unaffected.
	*/
	protected native void enterEvent(QEvent arg1);
	/**	
		 Overridden for internal reasons; the API remains unaffected.
		   		@short    Overridden for internal reasons; the API remains unaffected.
	*/
	protected native void leaveEvent(QEvent arg1);
	/**	
		 Catch parent palette changes
		   		@short    Catch parent palette changes
	*/
	public native boolean event(QEvent e);
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
