/***************************************************************************
                            HTMLBRElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLBRELEMENT_H
#define HTMLBRELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Force a line break. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/text.-[html edef]-BR"> BR
 element definition </a> in HTML 4.0.

 
 @short 
 Force a line break.
*/

@interface HTMLBRElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 Control flow of text around floats. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.-[html adef]-clear">
 clear attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
- (NSString *) clear;

/** 
 see @ref clear
     
*/
- setClear: (NSString *)arg1;
@end

#endif
