/***************************************************************************
                            HTMLBaseElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLBASEELEMENT_H
#define HTMLBASEELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Document base URI. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.-[html edef]-BASE">
 BASE element definition </a> in HTML 4.0.

 
 @short 
 Document base URI.
*/

@interface HTMLBaseElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 The base URI See the <a
 href="http://www.w3.org/TR/REC-html40/struct/links.-[html adef]-href-BASE">
 href attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) href;

/** 
 see @ref href
     
*/
- setHref: (NSString *)arg1;

/** 
 The default target frame. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.-[html adef]-target">
 target attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) target;

/** 
 see @ref target
     
*/
- setTarget: (NSString *)arg1;
@end

#endif
