/***************************************************************************
                            HTMLFrameSetElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLFRAMESETELEMENT_H
#define HTMLFRAMESETELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Create a grid of frames. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.-[html edef]-FRAMESET">
 FRAMESET element definition </a> in HTML 4.0.

 
 @short 
 Create a grid of frames.
*/

@interface HTMLFrameSetElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 The number of columns of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.-[html adef]-cols-FRAMESET">
 cols attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) cols;

/** 
 see @ref cols
     
*/
- setCols: (NSString *)arg1;

/** 
 The number of rows of frames in the frameset. See the <a
 href="http://www.w3.org/TR/REC-html40/present/frames.-[html adef]-rows-FRAMESET">
 rows attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) rows;

/** 
 see @ref rows
     
*/
- setRows: (NSString *)arg1;
@end

#endif
