/***************************************************************************
                            HTMLLIElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLLIELEMENT_H
#define HTMLLIELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 List item. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html edef]-LI">
 LI element definition </a> in HTML 4.0.

 
 @short 
 List item.
*/

@interface HTMLLIElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 List item bullet style. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html adef]-type-LI">
 type attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
- (NSString *) type;

/** 
 see @ref type
     
*/
- setType: (NSString *)arg1;

/** 
 Reset sequence number when used in <code> OL </code> See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html adef]-value-LI">
 value attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
- (long) value;

/** 
 see @ref value
     
*/
- setValue: (long)arg1;
@end

#endif
