/***************************************************************************
                            HTMLLabelElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLLABELELEMENT_H
#define HTMLLABELELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Form field label text. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html edef]-LABEL">
 LABEL element definition </a> in HTML 4.0.

 
 @short 
 Form field label text.
*/
@class HTMLFormElement; 

@interface HTMLLabelElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 Returns the <code> FORM </code> element containing this
 control. Returns null if this control is not within the context
 of a form.
 deprecated - don't use. Provided for KDE2 compatibility only.
     
*/
- (HTMLFormElement*) form;

/** 
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html adef]-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) accessKey;

/** 
 see @ref accessKey
     
*/
- setAccessKey: (NSString *)arg1;

/** 
 This attribute links this label with another form control by
 <code> id </code> attribute. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html adef]-for">
 for attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) htmlFor;

/** 
 see @ref htmlFor
     
*/
- setHtmlFor: (NSString *)arg1;
@end

#endif
