/***************************************************************************
                            HTMLMapElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLMAPELEMENT_H
#define HTMLMAPELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Client-side image map. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.-[html edef]-MAP">
 MAP element definition </a> in HTML 4.0.

 
 @short 
 Client-side image map.
*/
@class HTMLCollection; 

@interface HTMLMapElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 The list of areas defined for the image map.

     
*/
- (HTMLCollection*) areas;

/** 
 Names the map (for use with <code> usemap </code> ). See the <a
 href="http://www.w3.org/TR/REC-html40/struct/objects.-[html adef]-name-MAP">
 name attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) name;

/** 
 see @ref name
     
*/
- setName: (NSString *)arg1;
@end

#endif
