/***************************************************************************
                            HTMLModElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLMODELEMENT_H
#define HTMLMODELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Notice of modification to part of a document. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/text.-[html edef]-ins">
 INS </a> and <a
 href="http://www.w3.org/TR/REC-html40/struct/text.-[html edef]-del">
 DEL </a> element definitions in HTML 4.0.

 
 @short 
 Notice of modification to part of a document.
*/

@interface HTMLModElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 A URI designating a document that describes the reason for the
 change. See the <a href="http://www.w3.org/TR/REC-html40/">
 cite attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) cite;

/** 
 see @ref cite
     
*/
- setCite: (NSString *)arg1;

/** 
 The date and time of the change. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/text.-[html adef]-datetime">
 datetime attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) dateTime;

/** 
 see @ref dateTime
     
*/
- setDateTime: (NSString *)arg1;
@end

#endif
