/***************************************************************************
                            HTMLOptGroupElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLOPTGROUPELEMENT_H
#define HTMLOPTGROUPELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Group options together in logical subdivisions. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html edef]-OPTGROUP">
 OPTGROUP element definition </a> in HTML 4.0.

 
 @short 
 Group options together in logical subdivisions.
*/

@interface HTMLOptGroupElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 The control is unavailable in this context. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html adef]-disabled">
 disabled attribute definition </a> in HTML 4.0.

     
*/
- (BOOL) disabled;

/** 
 see @ref disabled
     
*/
- setDisabled: (BOOL)arg1;

/** 
 Assigns a label to this option group. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.-[html adef]-label-OPTGROUP">
 label attribute definition </a> in HTML 4.0.

     
*/
- (NSString *) label;

/** 
 see @ref label
     
*/
- setLabel: (NSString *)arg1;
@end

#endif
