/***************************************************************************
                            HTMLUListElement.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLULISTELEMENT_H
#define HTMLULISTELEMENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/HTMLElement.h>

/**

 Unordered list. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html edef]-UL">
 UL element definition </a> in HTML 4.0.

 
 @short 
 Unordered list.
*/
@interface HTMLUListElement : HTMLElement 
- init;
- copyWithZone: (NSZone *) zone;
- initWithDOMNode: (DOMNode*)other;
- (void) dealloc;

/** 
 Reduce spacing between list items. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html adef]-compact">
 compact attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
- (BOOL) compact;

/** 
 see @ref compact
     
*/
- setCompact: (BOOL)arg1;

/** 
 Bullet style. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/lists.-[html adef]-type-UL">
 type attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
- (NSString *) type;

/** 
 see @ref type
     
*/
- setType: (NSString *)arg1;
@end

#endif
