/***************************************************************************
                            KCookie.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KCOOKIE_H
#define KCOOKIE_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QtSupport.h>

/**

 Utility class to access the authentication tokens needed to run a KDE
 program (X11 and DCOP cookies).
 
 @short 
 Utility class to access the authentication tokens needed to run a KDE
 program (X11 and DCOP cookies).
*/
@interface  KCookie : NSObject <QtSupport>
{
@private
	void * _qt;
	BOOL  _allocatedInObjcWorld;
}
- init;

/**  Returns the X11 display. 
*/
- (NSString *) display;

/**  Returns the X11 magic cookie, if available. 
*/
- (NSString *) displayAuth;

/**  Select the DCOP transport to look for. Default: "local" *
*/
- setDcopTransport: (NSString *)dcopTransport;

/**  Returns the netid where the dcopserver is running 
*/
- (NSString *) dcopServer;

/**  
 Returns a list of magic cookies for DCOP protocol authentication. 
 The order is the same as in -dcopServer.
     
*/
- (NSString *) dcopAuth;

/**  Returns a list of magic cookies for the ICE protocol. 
*/
- (NSString *) iceAuth;
@end

#endif
