/***************************************************************************
                            KScanDialogFactory.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KSCANDIALOGFACTORY_H
#define KSCANDIALOGFACTORY_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <kdeobjc/KLibFactory.h>

/**

 A factory for creating a KScanDialog. You need to reimplement
 @ref -createDialog.

 
 @short 
 A factory for creating a KScanDialog.
*/
@class KScanDialog; 

@interface KScanDialogFactory : KLibFactory 
- (void) dealloc;

/** 
 Your library should reimplement this method to return your KScanDialog
 derived dialog.
     
*/
- (KScanDialog*) createDialog: (QWidget *)parent name: (NSString *)name modal: (BOOL)modal;
- (KScanDialog*) createDialog;
@end

/** Override these methods in subclasses of KScanDialogFactory to customise event handling behaviour */
@protocol KScanDialogFactoryEventHandling
- childEvent:(QChildEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
@end


#endif
