/***************************************************************************
                            KServiceOffer.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KSERVICEOFFER_H
#define KSERVICEOFFER_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QtSupport.h>

/**

 This class holds the characteristics of a service offer
 (whether it can be a default offer or not, how big is the preference
 for this offer, ...)

 @short Holds the characteristics of a service offer.
 
*/

@interface  KServiceOffer : NSObject <QtSupport>
{
@private
	void * _qt;
	BOOL  _allocatedInObjcWorld;
}
- init;
- copyWithZone: (NSZone *) zone;
//- initWithService_Ptr: (KService_Ptr*)_service _pref: (int)_pref _default: (BOOL)_default;

/** 
 Is it allowed to use this service for default actions
 (e.g. Left Click in a file manager, or KRun in general)
   
*/
- (BOOL) allowAsDefault;

/** 
 The bigger this number is, the better is this service.
   
*/
- (int) preference;

/** 
 The service which this offer is about.
   
*/
//- (KService_Ptr*) service;

/** 
 Whether the entry is valid
   
*/
- (BOOL) isValid;
@end

#endif
