/***************************************************************************
                            KTabCtl.h -  description
                             -------------------
    begin                : Fri Mar  8 13:55:08 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Mar  8 13:55:08 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef KTABCTL_H
#define KTABCTL_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QWidget.h>

/**
 
 Tabbed dialog with extended features.
 KTabCtl is very similar to QTabDialog, with the following differences:

 @author Alexander Sanda (alex@darkstar.ping.at)

 @version $Id: KTabCtl.h,v 1.3 2002/03/15 02:12:23 rdale Exp $

 @short  
 Tabbed dialog with extended features.
*/
@interface KTabCtl : QWidget 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- init;
- (void) dealloc;
- show;
- setFont: (QFont *)font;
- setTabFont: (QFont *)font;
- addTab: (QWidget *)arg1 string: (NSString *)arg2;
- (BOOL) isTabEnabled: (NSString *)arg1;
- setTabEnabled: (NSString *)arg1 bool: (BOOL)arg2;
- setBorder: (BOOL)arg1;
- setShape: (int)shape;
- (QSize*) sizeHint;
- setSizes;
- (QRect*) getChildRect;
- showTab: (int)i;
@end

/** Override these methods in subclasses of KTabCtl to customise event handling behaviour */
@protocol KTabCtlEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
