/***************************************************************************
                            QDir.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QDIR_H
#define QDIR_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QtSupport.h>

/**

* $Id: QDir.h,v 1.2 2001/11/21 23:39:01 rdale Exp $
*
* Definition of QFileInfo class
*
* Created : 950628
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the tools module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qfileinfo.
*/
@interface  QDir : NSObject <QtSupport>
{
@private
	void * _qt;
	BOOL  _allocatedInObjcWorld;
}
- init;
- initWithText: (NSString *)path nameFilter: (NSString *)nameFilter sortSpec: (int)sortSpec filterSpec: (int)filterSpec;
- initWithText: (NSString *)path ;
- copyWithZone: (NSZone *) zone;
- (void) dealloc;
- setPath: (NSString *)path;
- (NSString *) path;
- (NSString *) absPath;
- (NSString *) canonicalPath;
- (NSString *) dirName;
- (NSString *) filePath: (NSString *)fileName acceptAbsPath: (BOOL)acceptAbsPath;
- (NSString *) absFilePath: (NSString *)fileName acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) cd: (NSString *)dirName acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) cd: (NSString *)dirName ;
- (BOOL) cdUp;
- (NSString *) nameFilter;
- setNameFilter: (NSString *)nameFilter;
- (int) filter;
- setFilter: (int)filterSpec;
- (int) sorting;
- setSorting: (int)sortSpec;
- (BOOL) matchAllDirs;
- setMatchAllDirs: (BOOL)arg1;
- (unsigned int) count;
- (NSArray *) encodedEntryList: (int)filterSpec sortSpec: (int)sortSpec;
- (NSArray *) encodedEntryList: (NSString *)nameFilter filterSpec: (int)filterSpec sortSpec: (int)sortSpec;
- (NSArray *) entryList: (int)filterSpec sortSpec: (int)sortSpec;
- (NSArray *) entryList: (NSString *)nameFilter filterSpec: (int)filterSpec sortSpec: (int)sortSpec;
- (NSArray *) entryInfoList: (int)filterSpec sortSpec: (int)sortSpec;
- (NSArray *) entryInfoList: (NSString *)nameFilter filterSpec: (int)filterSpec sortSpec: (int)sortSpec;
- (BOOL) mkdir: (NSString *)dirName acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) mkdir: (NSString *)dirName ;
- (BOOL) rmdir: (NSString *)dirName acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) rmdir: (NSString *)dirName ;
- (BOOL) isReadable;
- (BOOL) exists;
- (BOOL) isRoot;
- (BOOL) isRelative;
- convertToAbs;
- (BOOL) remove: (NSString *)fileName acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) remove: (NSString *)fileName ;
- (BOOL) rename: (NSString *)name newName: (NSString *)newName acceptAbsPaths: (BOOL)acceptAbsPaths;
- (BOOL) rename: (NSString *)name newName: (NSString *)newName ;
- (BOOL) exists: (NSString *)name acceptAbsPath: (BOOL)acceptAbsPath;
- (BOOL) exists: (NSString *)name ;
+ (NSString *) convertSeparators: (NSString *)pathName;
+ (NSArray *) drives;
+ (char) separator;
+ (BOOL) setCurrent: (NSString *)path;
+ (QDir*) current;
+ (QDir*) home;
+ (QDir*) root;
+ (NSString *) currentDirPath;
+ (NSString *) homeDirPath;
+ (NSString *) rootDirPath;
+ (BOOL) matchWithFilters: (NSArray *)filters fileName: (NSString *)fileName;
+ (BOOL) matchWithFilter: (NSString *)filter fileName: (NSString *)fileName;
+ (NSString *) cleanDirPath: (NSString *)dirPath;
+ (BOOL) isRelativePath: (NSString *)path;
+ (int) Dirs;
+ (int) Files;
+ (int) Drives;
+ (int) NoSymLinks;
+ (int) All;
+ (int) TypeMask;
+ (int) Readable;
+ (int) Writable;
+ (int) Executable;
+ (int) RWEMask;
+ (int) Modified;
+ (int) Hidden;
+ (int) System;
+ (int) AccessMask;
+ (int) DefaultFilter;
+ (int) Name;
+ (int) Time;
+ (int) Size;
+ (int) Unsorted;
+ (int) SortByMask;
+ (int) DirsFirst;
+ (int) Reversed;
+ (int) IgnoreCase;
+ (int) DefaultSort;
@end

#endif
