/***************************************************************************
                            QEvent.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QEVENT_H
#define QEVENT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/Qt.h>

/**

* $Id: QEvent.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of event classes
*
* Created : 931029
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the kernel module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qevent.
*/
@interface QEvent : Qt 
- initWithInt: (int)type;
- (void) dealloc;
- (int) type;
- (BOOL) spontaneous;
+ (int) None;
+ (int) Timer;
+ (int) MouseButtonPress;
+ (int) MouseButtonRelease;
+ (int) MouseButtonDblClick;
+ (int) MouseMove;
+ (int) KeyPress;
+ (int) KeyRelease;
+ (int) FocusIn;
+ (int) FocusOut;
+ (int) Enter;
+ (int) Leave;
+ (int) Paint;
+ (int) Move;
+ (int) Resize;
+ (int) Create;
+ (int) Destroy;
+ (int) Show;
+ (int) Hide;
+ (int) Close;
+ (int) Quit;
+ (int) Reparent;
+ (int) ShowMinimized;
+ (int) ShowNormal;
+ (int) WindowActivate;
+ (int) WindowDeactivate;
+ (int) ShowToParent;
+ (int) HideToParent;
+ (int) ShowMaximized;
+ (int) ShowFullScreen;
+ (int) Accel;
+ (int) Wheel;
+ (int) AccelAvailable;
+ (int) CaptionChange;
+ (int) IconChange;
+ (int) ParentFontChange;
+ (int) ApplicationFontChange;
+ (int) ParentPaletteChange;
+ (int) ApplicationPaletteChange;
+ (int) PaletteChange;
+ (int) Clipboard;
+ (int) Speech;
+ (int) SockAct;
+ (int) AccelOverride;
+ (int) DeferredDelete;
+ (int) DragEnter;
+ (int) DragMove;
+ (int) DragLeave;
+ (int) Drop;
+ (int) DragResponse;
+ (int) ChildInserted;
+ (int) ChildRemoved;
+ (int) LayoutHint;
+ (int) ShowWindowRequest;
+ (int) ActivateControl;
+ (int) DeactivateControl;
+ (int) ContextMenu;
+ (int) IMStart;
+ (int) IMCompose;
+ (int) IMEnd;
+ (int) Accessibility;
+ (int) Tablet;
+ (int) User;
+ (int) MaxUser;
@end

#endif
