/***************************************************************************
                            QIODevice.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QIODEVICE_H
#define QIODEVICE_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QtSupport.h>

/**

* $Id: QIODevice.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QIODevice class
*
* Created : 940913
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the tools module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qiodevice.
*/

@class QByteArray;

@protocol QIODeviceInterface
- (void) dealloc;
- (int) flags;
- (int) mode;
- (int) state;
- (BOOL) isDirectAccess;
- (BOOL) isSequentialAccess;
- (BOOL) isCombinedAccess;
- (BOOL) isBuffered;
- (BOOL) isRaw;
- (BOOL) isSynchronous;
- (BOOL) isAsynchronous;
- (BOOL) isTranslated;
- (BOOL) isReadable;
- (BOOL) isWritable;
- (BOOL) isReadWrite;
- (BOOL) isInactive;
- (BOOL) isOpen;
- (int) status;
- resetStatus;
- (BOOL) open: (int)mode;
- close;
- flush;
- (int) size;
- (int) at;
- (BOOL) at: (int)arg1;
- (BOOL) atEnd;
- (BOOL) reset;
- (long) readBlock: (NSString *)data maxlen: (long)maxlen;
- (long) writeBlock: (NSString *)data len: (long)len;
- (long) readLine: (NSString *)data maxlen: (long)maxlen;
- (long) writeBlock: (QByteArray*)data;
- (QByteArray*) readAll;
- (int) getch;
- (int) putch: (int)arg1;
- (int) ungetch: (int)arg1;
@end

@interface QIODevice : NSObject <QtSupport,QIODeviceInterface>
{
@private
	void * _qt;
	BOOL  _allocatedInObjcWorld;
}
@end

#endif
