/***************************************************************************
                            QInputDialog.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QINPUTDIALOG_H
#define QINPUTDIALOG_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QDialog.h>

@class QContextMenuEvent; 
@class QIMEvent; 
@class QTabletEvent; 

@interface QInputDialog : QDialog 
+ (NSString *) getText: (NSString *)caption label: (NSString *)label echo: (int)echo text: (NSString *)text ok: (int*)ok parent: (QWidget *)parent name: (NSString *)name;
+ (int) getInteger: (NSString *)caption label: (NSString *)label num: (int)num from: (int)from to: (int)to step: (int)step ok: (int*)ok parent: (QWidget *)parent name: (NSString *)name;
+ (int) getInteger: (NSString *)caption label: (NSString *)label ;
+ (double) getDouble: (NSString *)caption label: (NSString *)label num: (double)num from: (double)from to: (double)to decimals: (int)decimals ok: (int*)ok parent: (QWidget *)parent name: (NSString *)name;
+ (double) getDouble: (NSString *)caption label: (NSString *)label ;
+ (NSString *) getItem: (NSString *)caption label: (NSString *)label list: (NSArray *)list current: (int)current editable: (BOOL)editable ok: (int*)ok parent: (QWidget *)parent name: (NSString *)name;
@end

/** Override these methods in subclasses of QInputDialog to customise event handling behaviour */
@protocol QInputDialogEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
