/***************************************************************************
                            QLineEdit.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QLINEEDIT_H
#define QLINEEDIT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QFrame.h>

/**

* $Id: QLineEdit.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QSpinBox widget class
*
* Created : 1997
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the widgets module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qspinbox.
*/
@class QContextMenuEvent; 
@class QIMEvent; 
@class QPalette; 
@class QPopupMenu; 
@class QTabletEvent; 
@class QValidator; 

@interface QLineEdit : QFrame 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- initWithWidget: (QWidget *)parent ;
- initWithText: (NSString *)arg1 parent: (QWidget *)parent name: (NSString *)name;
- initWithText: (NSString *)arg1 parent: (QWidget *)parent ;
- (void) dealloc;
- (NSString *) text;
- (NSString *) displayText;
- (int) maxLength;
- (BOOL) frame;
- (int) echoMode;
- (BOOL) isReadOnly;
- (QValidator*) validator;
- (QSize*) sizeHint;
- (QSize*) minimumSizeHint;
- (int) cursorPosition;
- (BOOL) validateAndSet: (NSString *)arg1 int: (int)arg2 int: (int)arg3 int: (int)arg4;
- (int) alignment;
- cursorLeft: (BOOL)mark steps: (int)steps;
- cursorLeft: (BOOL)mark ;
- cursorRight: (BOOL)mark steps: (int)steps;
- cursorRight: (BOOL)mark ;
- cursorForward: (BOOL)mark steps: (int)steps;
- cursorForward: (BOOL)mark ;
- cursorBackward: (BOOL)mark steps: (int)steps;
- cursorBackward: (BOOL)mark ;
- cursorWordForward: (BOOL)mark;
- cursorWordBackward: (BOOL)mark;
- backspace;
- del;
- home: (BOOL)mark;
- end: (BOOL)mark;
- setEdited: (BOOL)arg1;
- (BOOL) edited;
- (BOOL) hasSelectedText;
- (NSString *) selectedText;
- (BOOL) getSelection: (int*)start end: (int*)end;
- (BOOL) isUndoAvailable;
- (BOOL) isRedoAvailable;
- (BOOL) hasMarkedText;
- (NSString *) markedText;
- (BOOL) dragEnabled;
- (int) characterAt: (int)xpos chr: (unichar *)chr;
- setText: (NSString *)arg1;
- selectAll;
- deselect;
- clearValidator;
- insert: (NSString *)arg1;
- clear;
- undo;
- redo;
- setMaxLength: (int)arg1;
- setFrame: (BOOL)arg1;
- setEchoMode: (int)arg1;
- setReadOnly: (BOOL)arg1;
- setValidator: (QValidator *)arg1;
- setFont: (QFont *)arg1;
- setPalette: (QPalette *)arg1;
- setSelection: (int)arg1 int: (int)arg2;
- setCursorPosition: (int)arg1;
- setAlignment: (int)flag;
- cut;
- copy;
- paste;
- setDragEnabled: (BOOL)b;
- (BOOL) event: (QEvent *)arg1;
- drawContents: (QPainter *)painter;
- repaintArea: (int)arg1 int: (int)arg2;
- (QPopupMenu*) createPopupMenu;
- windowActivationChange: (BOOL)arg1;
+ (int) Normal;
+ (int) NoEcho;
+ (int) Password;
@end

/** Override these methods in subclasses of QLineEdit to customise event handling behaviour */
@protocol QLineEditEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) e;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) e;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
