/***************************************************************************
                            QMainWindow.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QMAINWINDOW_H
#define QMAINWINDOW_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QWidget.h>

/**

* $Id: QMainWindow.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QToolBar class
*
* Created : 980306
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the widgets module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qtoolbar.
*/
@class QContextMenuEvent; 
@class QDockArea; 
@class QDockWindow; 
@class QIMEvent; 
@class QStyle; 
@class QTabletEvent; 

@class QMenuBar; 
@class QPopupMenu; 
@class QStatusBar; 
@class QToolTipGroup; 

@interface QMainWindow : QWidget 
- initWithWidget: (QWidget *)parent name: (NSString *)name f: (int)f;
- init;
- (void) dealloc;
- (QMenuBar*) menuBar;
- (QStatusBar*) statusBar;
- (QToolTipGroup*) toolTipGroup;
- setCentralWidget: (QWidget *)arg1;
- (QWidget*) centralWidget;
- setDockEnabled: (int)dock enable: (BOOL)enable;
- (BOOL) isDockEnabled: (int)dock;
- (BOOL) isDockAreaEnabled: (QDockArea*)area;
- setDockEnabled: (QDockWindow*)tb dock: (int)dock enable: (BOOL)enable;
- (BOOL) isDockEnabled: (QDockWindow*)tb dock: (int)dock;
- (BOOL) isDockEnabled: (QDockWindow*)tb area: (QDockArea*)area;
- addDockWindow: (QDockWindow*)arg1 int: (int)arg2 newLine: (BOOL)newLine;
- addDockWindow: (QDockWindow*)arg1 ;
- addDockWindow: (QDockWindow*)arg1 label: (NSString *)label int: (int)arg2 newLine: (BOOL)newLine;
- addDockWindow: (QDockWindow*)arg1 label: (NSString *)label ;
- moveDockWindow: (QDockWindow*)arg1 int: (int)arg2;
- moveDockWindow: (QDockWindow*)arg1 ;
- moveDockWindow: (QDockWindow*)arg1 int: (int)arg2 nl: (BOOL)nl index: (int)index extraOffset: (int)extraOffset;
- moveDockWindow: (QDockWindow*)arg1 int: (int)arg2 nl: (BOOL)nl index: (int)index ;
- removeDockWindow: (QDockWindow*)arg1;
- show;
- (QSize*) sizeHint;
- (QSize*) minimumSizeHint;
- (BOOL) rightJustification;
- (BOOL) usesBigPixmaps;
- (BOOL) usesTextLabel;
- (BOOL) dockWindowsMovable;
- (BOOL) opaqueMoving;
- (BOOL) eventFilter: (QObject *)arg1 event: (QEvent *)arg2;
- (BOOL) getLocation: (QDockWindow*)tb dock: (int)dock index: (int)index nl: (BOOL)nl extraOffset: (int)extraOffset;
- lineUpDockWindows: (BOOL)keepNewLines;
- lineUpDockWindows;
- (BOOL) isDockMenuEnabled;
- (BOOL) hasDockWindow: (QDockWindow*)dw;
- addToolBar: (QDockWindow*)arg1 int: (int)arg2 newLine: (BOOL)newLine;
- addToolBar: (QDockWindow*)arg1 ;
- addToolBar: (QDockWindow*)arg1 label: (NSString *)label int: (int)arg2 newLine: (BOOL)newLine;
- addToolBar: (QDockWindow*)arg1 label: (NSString *)label ;
- moveToolBar: (QDockWindow*)arg1 int: (int)arg2;
- moveToolBar: (QDockWindow*)arg1 ;
- moveToolBar: (QDockWindow*)arg1 int: (int)arg2 nl: (BOOL)nl index: (int)index extraOffset: (int)extraOffset;
- moveToolBar: (QDockWindow*)arg1 int: (int)arg2 nl: (BOOL)nl index: (int)index ;
- removeToolBar: (QDockWindow*)arg1;
- (BOOL) toolBarsMovable;
- lineUpToolBars: (BOOL)keepNewLines;
- lineUpToolBars;
- (QDockArea*) dockingArea: (QPoint*)p;
- (QDockArea*) leftDock;
- (QDockArea*) rightDock;
- (QDockArea*) topDock;
- (QDockArea*) bottomDock;
- (BOOL) isCustomizable;
- (BOOL) appropriate: (QDockWindow*)dw;
- (QPopupMenu*) createDockWindowMenu: (int)dockWindows;
- (QPopupMenu*) createDockWindowMenu;
- setRightJustification: (BOOL)arg1;
- setUsesBigPixmaps: (BOOL)arg1;
- setUsesTextLabel: (BOOL)arg1;
- setDockWindowsMovable: (BOOL)arg1;
- setOpaqueMoving: (BOOL)arg1;
- setDockMenuEnabled: (BOOL)arg1;
- whatsThis;
- setAppropriate: (QDockWindow*)dw a: (BOOL)a;
- customize;
- setToolBarsMovable: (BOOL)arg1;
- (BOOL) event: (QEvent *)arg1;
- styleChange: (QStyle*)arg1;
- setUpLayout;
- (BOOL) showDockMenu: (QPoint*)globalPos;
- menuAboutToShow;
+ (int) OnlyToolBars;
+ (int) NoToolBars;
+ (int) AllDockWindows;
@end

/** Override these methods in subclasses of QMainWindow to customise event handling behaviour */
@protocol QMainWindowEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
