/***************************************************************************
                            QMessageBox.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QMESSAGEBOX_H
#define QMESSAGEBOX_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QDialog.h>

@class QContextMenuEvent; 
@class QIMEvent; 
@class QPixmap; 
@class QStyle; 
@class QTabletEvent; 

@interface QMessageBox : QDialog 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- init;
- initWithText: (NSString *)caption text: (NSString *)text icon: (int)icon button0: (int)button0 button1: (int)button1 button2: (int)button2 parent: (QWidget *)parent name: (NSString *)name modal: (BOOL)modal f: (int)f;
- initWithText: (NSString *)caption text: (NSString *)text icon: (int)icon button0: (int)button0 button1: (int)button1 button2: (int)button2 ;
- (void) dealloc;
- (NSString *) text;
- setText: (NSString *)arg1;
- (int) icon;
- setIcon: (int)arg1;
- setIconWithPixmap: (QPixmap *)arg1;
- (QPixmap*) iconPixmap;
- setIconPixmap: (QPixmap *)arg1;
- (NSString *) buttonText: (int)button;
- setButtonText: (int)button string: (NSString *)arg1;
- adjustSize;
- (int) textFormat;
- setTextFormat: (int)arg1;
+ (int) information: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 button1: (int)button1 button2: (int)button2;
+ (int) information: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 ;
+ (int) information: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0Text: (NSString *)button0Text button1Text: (NSString *)button1Text button2Text: (NSString *)button2Text defaultButtonNumber: (int)defaultButtonNumber escapeButtonNumber: (int)escapeButtonNumber;
+ (int) information: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text ;
+ (int) warning: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 button1: (int)button1 button2: (int)button2;
+ (int) warning: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 button1: (int)button1 ;
+ (int) warning: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0Text: (NSString *)button0Text button1Text: (NSString *)button1Text button2Text: (NSString *)button2Text defaultButtonNumber: (int)defaultButtonNumber escapeButtonNumber: (int)escapeButtonNumber;
+ (int) warning: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text ;
+ (int) critical: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 button1: (int)button1 button2: (int)button2;
+ (int) critical: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0: (int)button0 button1: (int)button1 ;
+ (int) critical: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text button0Text: (NSString *)button0Text button1Text: (NSString *)button1Text button2Text: (NSString *)button2Text defaultButtonNumber: (int)defaultButtonNumber escapeButtonNumber: (int)escapeButtonNumber;
+ (int) critical: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text ;
+ about: (QWidget *)parent caption: (NSString *)caption text: (NSString *)text;
+ aboutQt: (QWidget *)parent caption: (NSString *)caption;
+ aboutQt: (QWidget *)parent ;
+ (int) message: (NSString *)caption text: (NSString *)text buttonText: (NSString *)buttonText parent: (QWidget *)parent string: (NSString *)arg1;
+ (int) message: (NSString *)caption text: (NSString *)text ;
+ (BOOL) query: (NSString *)caption text: (NSString *)text yesButtonText: (NSString *)yesButtonText noButtonText: (NSString *)noButtonText parent: (QWidget *)parent string: (NSString *)arg1;
+ (BOOL) query: (NSString *)caption text: (NSString *)text ;
+ (QPixmap*) standardIcon: (int)icon int: (int)arg1;
+ (QPixmap*) standardIcon: (int)icon;
- styleChanged: (QStyle*)arg1;
+ (int) NoIcon;
+ (int) Information;
+ (int) Warning;
+ (int) Critical;
+ (int) NoButton;
+ (int) Ok;
+ (int) Cancel;
+ (int) Yes;
+ (int) No;
+ (int) Abort;
+ (int) Retry;
+ (int) Ignore;
+ (int) ButtonMask;
+ (int) Default;
+ (int) Escape;
+ (int) FlagMask;
@end

/** Override these methods in subclasses of QMessageBox to customise event handling behaviour */
@protocol QMessageBoxEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
