/***************************************************************************
                            QMultiLineEdit.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QMULTILINEEDIT_H
#define QMULTILINEEDIT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QTextEdit.h>

@interface QMultiLineEdit : QTextEdit 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- init;
- (void) dealloc;
- (NSString *) textLine: (int)line;
- (int) numLines;
- insertLine: (NSString *)s line: (int)line;
- insertLine: (NSString *)s ;
- insertAt: (NSString *)s line: (int)line col: (int)col mark: (BOOL)mark;
- insertAt: (NSString *)s line: (int)line col: (int)col ;
- removeLine: (int)line;
- setCursorPosition: (int)line col: (int)col mark: (BOOL)mark;
- setCursorPosition: (int)line col: (int)col ;
- (BOOL) atBeginning;
- (BOOL) atEnd;
- setAlignment: (int)flags;
- (int) alignment;
- setEdited: (BOOL)arg1;
- (BOOL) edited;
- (BOOL) hasMarkedText;
- (NSString *) markedText;
- cursorWordForward: (BOOL)mark;
- cursorWordBackward: (BOOL)mark;
- (BOOL) autoUpdate;
- setAutoUpdate: (BOOL)arg1;
- (int) totalWidth;
- (int) totalHeight;
- (int) maxLines;
- setMaxLines: (int)arg1;
- deselect;
- (QPoint*) cursorPoint;
- insertAndMark: (NSString *)arg1 mark: (BOOL)mark;
- newLine;
- killLine;
- pageUp: (BOOL)mark;
- pageUp;
- pageDown: (BOOL)mark;
- pageDown;
- cursorLeft: (BOOL)mark wrap: (BOOL)wrap;
- cursorLeft;
- cursorRight: (BOOL)mark wrap: (BOOL)wrap;
- cursorRight;
- cursorUp: (BOOL)mark;
- cursorUp;
- cursorDown: (BOOL)mark;
- cursorDown;
- backspace;
- home: (BOOL)mark;
- home;
- end: (BOOL)mark;
- end;
- (BOOL) getMarkedRegion: (int*)line1 col1: (int*)col1 line2: (int*)line2 col2: (int*)col2;
- (int) lineLength: (int)row;
@end

/** Override these methods in subclasses of QMultiLineEdit to customise event handling behaviour */
@protocol QMultiLineEditEventHandling
- keyPressEvent:(QKeyEvent*) e;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- viewportDragMoveEvent:(QDragMoveEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- contentsWheelEvent:(QWheelEvent*) e;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contentsContextMenuEvent:(QContextMenuEvent*) e;
- viewportContextMenuEvent:(QContextMenuEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- viewportMousePressEvent:(QMouseEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- viewportMouseReleaseEvent:(QMouseEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- viewportMouseDoubleClickEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- viewportDragLeaveEvent:(QDragLeaveEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- contentsDropEvent:(QDropEvent*) e;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- contentsDragLeaveEvent:(QDragLeaveEvent*) e;
- viewportDropEvent:(QDropEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- contentsMouseDoubleClickEvent:(QMouseEvent*) e;
- viewportDragEnterEvent:(QDragEnterEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- viewportMouseMoveEvent:(QMouseEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- contentsDragMoveEvent:(QDragMoveEvent*) e;
- moveEvent:(QMoveEvent*) arg1;
- contentsMouseReleaseEvent:(QMouseEvent*) e;
- viewportWheelEvent:(QWheelEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- contentsDragEnterEvent:(QDragEnterEvent*) e;
- contentsMouseMoveEvent:(QMouseEvent*) e;
- contentsMousePressEvent:(QMouseEvent*) e;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- viewportPaintEvent:(QPaintEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- viewportResizeEvent:(QResizeEvent*) arg1;
- resizeEvent:(QResizeEvent*) e;
@end


#endif
