/***************************************************************************
                            QPopupMenu.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QPOPUPMENU_H
#define QPOPUPMENU_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QFrame.h>
#include <qtobjc/QMenuData.h>

/**

* $Id: QPopupMenu.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QStyle class
*
* Created : 980616
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the kernel module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qstyle.
*/
@interface QPopupMenu : QFrame 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- init;
- (void) dealloc;
- popup: (QPoint*)pos indexAtPoint: (int)indexAtPoint;
- popup: (QPoint*)pos ;
- updateIntItem: (int)identifier;
- setCheckable: (BOOL)arg1;
- (BOOL) isCheckable;
- setFont: (QFont *)arg1;
- show;
- hide;
- (int) exec;
- (int) exec: (QPoint*)pos indexAtPoint: (int)indexAtPoint;
- (int) exec: (QPoint*)pos ;
- setActiveItem: (int)arg1;
- (QSize*) sizeHint;
- (int) idAt: (int)index;
- (int) idAtPoint: (QPoint*)pos;
- (BOOL) customWhatsThis;
- (int) insertTearOffHandle: (int)identifier index: (int)index;
- (int) insertTearOffHandle;
- activateItemAt: (int)index;
- (QRect*) itemGeometry: (int)index;
- (int) itemHeight: (int)arg1;
//- (int) menuItemHeight: (QMenuItem *)mi;
//- drawItem: (QPainter *)p tab: (int)tab mi: (QMenuItem *)mi act: (BOOL)act x: (int)x y: (int)y w: (int)w h: (int)h;
- drawContents: (QPainter *)arg1;
- styleChange: (QStyle*)arg1;
- (int) columns;
- (BOOL) focusNextPrevChild: (BOOL)next;
- (int) itemAtPos: (QPoint*)arg1 ignoreSeparator: (BOOL)ignoreSeparator;
- (int) itemAtPos: (QPoint*)arg1 ;
@end

@class QContextMenuEvent; 
@class QIMEvent; 
@class QStyle; 
@class QTabletEvent; 

@interface QPopupMenu (QMenuDataImplementation) <QMenuDataInterface>
@end

/** Override these methods in subclasses of QPopupMenu to customise event handling behaviour */
@protocol QPopupMenuEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) e;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
