/***************************************************************************
                            QProgressBar.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QPROGRESSBAR_H
#define QPROGRESSBAR_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QFrame.h>

@class QContextMenuEvent; 
@class QIMEvent; 
@class QStyle; 
@class QTabletEvent; 

@interface QProgressBar : QFrame 
- initWithWidget: (QWidget *)parent name: (NSString *)name f: (int)f;
- init;
- initWithInt: (int)totalSteps parent: (QWidget *)parent name: (NSString *)name f: (int)f;
- initWithInt: (int)totalSteps ;
- (int) totalSteps;
- (int) progress;
- (NSString *) progressString;
- (QSize*) sizeHint;
- (QSize*) minimumSizeHint;
- setCenterIndicator: (BOOL)on;
- (BOOL) centerIndicator;
- setIndicatorFollowsStyle: (BOOL)arg1;
- (BOOL) indicatorFollowsStyle;
- (BOOL) percentageVisible;
- setPercentageVisible: (BOOL)arg1;
- show;
- reset;
- setTotalSteps: (int)totalSteps;
- setProgress: (int)progress;
- drawContents: (QPainter *)arg1;
- (BOOL) setIndicator: (NSString *)progress_str progress: (int)progress totalSteps: (int)totalSteps;
- styleChange: (QStyle*)arg1;
@end

/** Override these methods in subclasses of QProgressBar to customise event handling behaviour */
@protocol QProgressBarEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
