/***************************************************************************
                            QTabBar.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QTABBAR_H
#define QTABBAR_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QWidget.h>

/**

* $Id: QTabBar.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QTabWidget class
*
* Created : 990318
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the widgets module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qtabwidget.
*/
@class QContextMenuEvent; 
@class QIMEvent; 
@class QStyle; 
@class QTabletEvent; 

@class QTab; 

@interface QTabBar : QWidget 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- init;
- (void) dealloc;
- (int) shape;
- setShape: (int)arg1;
- show;
- (int) addTab: (QTab*)arg1;
- (int) insertTab: (QTab*)arg1 index: (int)index;
- (int) insertTab: (QTab*)arg1 ;
- removeTab: (QTab*)arg1;
- setTabEnabled: (int)arg1 bool: (BOOL)arg2;
- (BOOL) isTabEnabled: (int)arg1;
- (QSize*) sizeHint;
- (QSize*) minimumSizeHint;
- (int) currentTab;
- (int) keyboardFocusTab;
- (QTab*) tab: (int)arg1;
- (QTab*) tabAt: (int)arg1;
- (int) indexOf: (int)arg1;
- (int) count;
- layoutTabs;
- (QTab*) selectTab: (QPoint*)p;
- removeToolTip: (int)index;
- setToolTip: (int)index tip: (NSString *)tip;
- (NSString *) toolTip: (int)index;
- setCurrentTabAtId: (int)arg1;
- setCurrentTab: (QTab*)arg1;
- paint: (QPainter *)arg1 tab: (QTab*)arg2 bool: (BOOL)arg3;
- paintLabel: (QPainter *)arg1 rect: (QRect*)arg2 tab: (QTab*)arg3 bool: (BOOL)arg4;
- styleChange: (QStyle*)arg1;
- fontChange: (QFont *)arg1;
+ (int) RoundedAbove;
+ (int) RoundedBelow;
+ (int) TriangularAbove;
+ (int) TriangularBelow;
@end

/** Override these methods in subclasses of QTabBar to customise event handling behaviour */
@protocol QTabBarEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) e;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) e;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
