/***************************************************************************
                            QToolButton.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QTOOLBUTTON_H
#define QTOOLBUTTON_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QButton.h>

/**

* $Id: QToolButton.h,v 1.2 2001/11/21 23:39:02 rdale Exp $
*
* Definition of QWhatsThis class
*
* Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
*
* This file is part of the widgets module of the Qt GUI Toolkit.
*
* This file may be distributed under the terms of the Q Public License
* as defined by Trolltech AS of Norway and appearing in the file
* LICENSE.QPL included in the packaging of this file.
*
* This file may be distributed and/or modified under the terms of the
* GNU General Public License version 2 as published by the Free Software
* Foundation and appearing in the file LICENSE.GPL included in the
* packaging of this file.
*
* Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
* licenses may use this file in accordance with the Qt Commercial License
* Agreement provided with the Software.
*
* This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
* WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
*   information about Qt Commercial License Agreements.
* See http://www.trolltech.com/qpl/ for QPL licensing information.
* See http://www.trolltech.com/gpl/ for GPL licensing information.
*
* Contact info@trolltech.com if any conditions of this licensing are
* not clear to you.
*
********************************************************************
 @short 
* $Id:  qt/qwhatsthis.
*/
@class QContextMenuEvent; 
@class QIMEvent; 
@class QIconSet; 
@class QPalette; 
@class QPopupMenu; 
@class QTabletEvent;
@class QToolBar;

@interface QToolButton : QButton 
- initWithWidget: (QWidget *)parent name: (NSString *)name;
- initWithWidget: (QWidget *)parent ;
- initWithIconSet: (QIconSet*)s textLabel: (NSString *)textLabel grouptext: (NSString *)grouptext receiver: (QObject *)receiver slot: (NSString *)slot parent: (QToolBar*)parent name: (NSString *)name;
- initWithIconSet: (QIconSet*)s textLabel: (NSString *)textLabel grouptext: (NSString *)grouptext receiver: (QObject *)receiver slot: (NSString *)slot parent: (QToolBar*)parent ;
- initWithType: (int)type parent: (QWidget *)parent name: (NSString *)name;
- initWithType: (int)type parent: (QWidget *)parent ;
- (void) dealloc;
- (QSize*) sizeHint;
- (QSize*) minimumSizeHint;
- setOnIconSet: (QIconSet*)arg1;
- setOffIconSet: (QIconSet*)arg1;
- setIconSet: (QIconSet*)arg1 on: (BOOL)on;
- (QIconSet*) onIconSet;
//- (QIconSet*) offIconSet: (int)arg1;
- (QIconSet*) iconSet: (BOOL)on;
- setIconSet: (QIconSet*)arg1;
- (QIconSet*) iconSet;
- (BOOL) usesBigPixmap;
- (BOOL) usesTextLabel;
- (NSString *) textLabel;
- setPopup: (QPopupMenu*)popup;
- (QPopupMenu*) popup;
- setPopupDelay: (int)delay;
- (int) popupDelay;
- openPopup;
- setAutoRaise: (BOOL)enable;
- (BOOL) autoRaise;
- setUsesBigPixmap: (BOOL)enable;
- setUsesTextLabel: (BOOL)enable;
- setTextLabel: (NSString *)arg1 bool: (BOOL)arg2;
- setToggleButton: (BOOL)enable;
- setOn: (BOOL)enable;
- toggle;
- setTextLabel: (NSString *)arg1;
- drawButton: (QPainter *)arg1;
- drawButtonLabel: (QPainter *)arg1;
- (BOOL) uses3D;
- (BOOL) eventFilter: (QObject *)o e: (QEvent *)e;
- paletteChange: (QPalette *)arg1;
@end

/** Override these methods in subclasses of QToolButton to customise event handling behaviour */
@protocol QToolButtonEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
