/***************************************************************************
                            QWizard.h -  description
                             -------------------
    begin                : Wed Nov 21 12:08:37 2001
    copyright            : (C) 2000-2001 Lost Highway Ltd. All rights reserved.
    email                : Lost_Highway@tipitina.demon.co.uk
    generated by         : duke@tipitina on Wed Nov 21 12:08:37 2001, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 ***************************************************************************/

#ifndef QWIZARD_H
#define QWIZARD_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <qtobjc/QDialog.h>

@class QPushButton;
@class QHBoxLayout;

@class QContextMenuEvent; 
@class QIMEvent; 
@class QTabletEvent; 

@interface QWizard : QDialog 
- initWithWidget: (QWidget *)parent name: (NSString *)name modal: (BOOL)modal f: (int)f;
- init;
- (void) dealloc;
- show;
- setFont: (QFont *)font;
- addPage: (QWidget *)arg1 string: (NSString *)arg2;
- insertPage: (QWidget *)arg1 string: (NSString *)arg2 int: (int)arg3;
- removePage: (QWidget *)arg1;
- (NSString *) title: (QWidget *)arg1;
- setTitle: (QWidget *)arg1 string: (NSString *)arg2;
- (QFont*) titleFont;
- setTitleFont: (QFont *)arg1;
- showPage: (QWidget *)arg1;
- (QWidget*) currentPage;
- (QWidget*) page: (int)arg1;
- (int) pageCount;
- (int) indexOf: (QWidget *)arg1;
- (BOOL) appropriate: (QWidget *)arg1;
- setAppropriate: (QWidget *)arg1 bool: (BOOL)arg2;
- (QPushButton*) backButton;
- (QPushButton*) nextButton;
- (QPushButton*) finishButton;
- (QPushButton*) cancelButton;
- (QPushButton*) helpButton;
- (BOOL) eventFilter: (QObject *)arg1 event: (QEvent *)arg2;
- setBackEnabled: (QWidget *)arg1 bool: (BOOL)arg2;
- setNextEnabled: (QWidget *)arg1 bool: (BOOL)arg2;
- setFinishEnabled: (QWidget *)arg1 bool: (BOOL)arg2;
- setHelpEnabled: (QWidget *)arg1 bool: (BOOL)arg2;
- setFinish: (QWidget *)arg1 bool: (BOOL)arg2;
- layOutButtonRow: (QHBoxLayout*)arg1;
- layOutTitleRow: (QHBoxLayout*)arg1 string: (NSString *)arg2;
- back;
- next;
- help;
@end

/** Override these methods in subclasses of QWizard to customise event handling behaviour */
@protocol QWizardEventHandling
- keyPressEvent:(QKeyEvent*) arg1;
- keyReleaseEvent:(QKeyEvent*) arg1;
- focusOutEvent:(QFocusEvent*) arg1;
- childEvent:(QChildEvent*) arg1;
- dragMoveEvent:(QDragMoveEvent*) arg1;
- leaveEvent:(QEvent*) arg1;
- tabletEvent:(QTabletEvent*) arg1;
- showEvent:(QShowEvent*) arg1;
- contextMenuEvent:(QContextMenuEvent*) arg1;
- mousePressEvent:(QMouseEvent*) arg1;
- imComposeEvent:(QIMEvent*) arg1;
- customEvent:(QCustomEvent*) arg1;
- mouseReleaseEvent:(QMouseEvent*) arg1;
- mouseDoubleClickEvent:(QMouseEvent*) arg1;
- dragLeaveEvent:(QDragLeaveEvent*) arg1;
- enterEvent:(QEvent*) arg1;
- focusInEvent:(QFocusEvent*) arg1;
- imEndEvent:(QIMEvent*) arg1;
- dropEvent:(QDropEvent*) arg1;
- dragEnterEvent:(QDragEnterEvent*) arg1;
- mouseMoveEvent:(QMouseEvent*) arg1;
- moveEvent:(QMoveEvent*) arg1;
- wheelEvent:(QWheelEvent*) arg1;
- hideEvent:(QHideEvent*) arg1;
- imStartEvent:(QIMEvent*) arg1;
- closeEvent:(QCloseEvent*) arg1;
- paintEvent:(QPaintEvent*) arg1;
- timerEvent:(QTimerEvent*) arg1;
- resizeEvent:(QResizeEvent*) arg1;
@end


#endif
